sdl2-2.5.5.0: Both high- and low-level bindings to the SDL library (version 2.0.6+).

Safe Haskell | Safe-Inferred
Language | Haskell2010

SDL.Event

Contents

- Polling events
- Registering user events
- Watching events
- Event data
  - Window events
  - Keyboard events
  - Mouse events
  - Joystick events
  - Controller events
  - Audio events
  - User events
  - Touch events
  - Gesture events
  - Drag and drop events
  - Unknown events
- Auxiliary event data

Description

SDL.Event exports an interface for working with the SDL event model. Event handling allows your application to receive input from the user. Internally, SDL stores all the events waiting to be handled in an event queue. Using functions like `pollEvent` and `waitEvent` you can observe and handle waiting input events.

The event queue itself is composed of a series of `Event` values, one for each waiting event. `Event` values are read from the queue with the `pollEvent` function and it is then up to the application to process the information stored with them.

Synopsis

- pollEvent :: MonadIO m => m (Maybe Event)
- pollEvents :: MonadIO m => m [Event]
- mapEvents :: MonadIO m => (Event -> m ()) -> m ()
- pumpEvents :: MonadIO m => m ()
- waitEvent :: MonadIO m => m Event
- waitEventTimeout :: MonadIO m => CInt -> m (Maybe Event)
- data RegisteredEventType a = RegisteredEventType {
  - pushRegisteredEvent :: a -> IO EventPushResult
  - getRegisteredEvent :: Event -> IO (Maybe a)
  }
- data RegisteredEventData = RegisteredEventData {
  - registeredEventWindow :: !(Maybe Window)
  - registeredEventCode :: !Int32
  - registeredEventData1 :: !(Ptr ())
  - registeredEventData2 :: !(Ptr ())
  }
- data EventPushResult
  - = EventPushSuccess
  - | EventPushFiltered
  - | EventPushFailure Text
- emptyRegisteredEvent :: RegisteredEventData
- registerEvent :: MonadIO m => (RegisteredEventData -> Timestamp -> IO (Maybe a)) -> (a -> IO RegisteredEventData) -> m (Maybe (RegisteredEventType a))
- type EventWatchCallback = Event -> IO ()
- data EventWatch
- addEventWatch :: MonadIO m => EventWatchCallback -> m EventWatch
- delEventWatch :: MonadIO m => EventWatch -> m ()
- data Event = Event {
  - eventTimestamp :: Timestamp
  - eventPayload :: EventPayload
  }
- type Timestamp = Word32
- data EventPayload
  - = WindowShownEvent !WindowShownEventData
  - | WindowHiddenEvent !WindowHiddenEventData
  - | WindowExposedEvent !WindowExposedEventData
  - | WindowMovedEvent !WindowMovedEventData
  - | WindowResizedEvent !WindowResizedEventData
  - | WindowSizeChangedEvent !WindowSizeChangedEventData
  - | WindowMinimizedEvent !WindowMinimizedEventData
  - | WindowMaximizedEvent !WindowMaximizedEventData
  - | WindowRestoredEvent !WindowRestoredEventData
  - | WindowGainedMouseFocusEvent !WindowGainedMouseFocusEventData
  - | WindowLostMouseFocusEvent !WindowLostMouseFocusEventData
  - | WindowGainedKeyboardFocusEvent !WindowGainedKeyboardFocusEventData
  - | WindowLostKeyboardFocusEvent !WindowLostKeyboardFocusEventData
  - | WindowClosedEvent !WindowClosedEventData
  - | KeyboardEvent !KeyboardEventData
  - | TextEditingEvent !TextEditingEventData
  - | TextInputEvent !TextInputEventData
  - | KeymapChangedEvent
  - | MouseMotionEvent !MouseMotionEventData
  - | MouseButtonEvent !MouseButtonEventData
  - | MouseWheelEvent !MouseWheelEventData
  - | JoyAxisEvent !JoyAxisEventData
  - | JoyBallEvent !JoyBallEventData
  - | JoyHatEvent !JoyHatEventData
  - | JoyButtonEvent !JoyButtonEventData
  - | JoyDeviceEvent !JoyDeviceEventData
  - | ControllerAxisEvent !ControllerAxisEventData
  - | ControllerButtonEvent !ControllerButtonEventData
  - | ControllerDeviceEvent !ControllerDeviceEventData
  - | AudioDeviceEvent !AudioDeviceEventData
  - | QuitEvent
  - | UserEvent !UserEventData
  - | SysWMEvent !SysWMEventData
  - | TouchFingerEvent !TouchFingerEventData
  - | TouchFingerMotionEvent !TouchFingerMotionEventData
  - | MultiGestureEvent !MultiGestureEventData
  - | DollarGestureEvent !DollarGestureEventData
  - | DropEvent !DropEventData
  - | ClipboardUpdateEvent
  - | UnknownEvent !UnknownEventData
- newtype WindowShownEventData = WindowShownEventData {
  - windowShownEventWindow :: Window
  }
- newtype WindowHiddenEventData = WindowHiddenEventData {
  - windowHiddenEventWindow :: Window
  }
- newtype WindowExposedEventData = WindowExposedEventData {
  - windowExposedEventWindow :: Window
  }
- data WindowMovedEventData = WindowMovedEventData {
  - windowMovedEventWindow :: !Window
  - windowMovedEventPosition :: !(Point V2 Int32)
  }
- data WindowResizedEventData = WindowResizedEventData {
  - windowResizedEventWindow :: !Window
  - windowResizedEventSize :: !(V2 Int32)
  }
- data WindowSizeChangedEventData = WindowSizeChangedEventData {
  - windowSizeChangedEventWindow :: !Window
  - windowSizeChangedEventSize :: !(V2 Int32)
  }
- newtype WindowMinimizedEventData = WindowMinimizedEventData {
  - windowMinimizedEventWindow :: Window
  }
- newtype WindowMaximizedEventData = WindowMaximizedEventData {
  - windowMaximizedEventWindow :: Window
  }
- newtype WindowRestoredEventData = WindowRestoredEventData {
  - windowRestoredEventWindow :: Window
  }
- newtype WindowGainedMouseFocusEventData = WindowGainedMouseFocusEventData {
  - windowGainedMouseFocusEventWindow :: Window
  }
- newtype WindowLostMouseFocusEventData = WindowLostMouseFocusEventData {
  - windowLostMouseFocusEventWindow :: Window
  }
- newtype WindowGainedKeyboardFocusEventData = WindowGainedKeyboardFocusEventData {
  - windowGainedKeyboardFocusEventWindow :: Window
  }
- newtype WindowLostKeyboardFocusEventData = WindowLostKeyboardFocusEventData {
  - windowLostKeyboardFocusEventWindow :: Window
  }
- newtype WindowClosedEventData = WindowClosedEventData {
  - windowClosedEventWindow :: Window
  }
- newtype SysWMEventData = SysWMEventData {
  - sysWMEventMsg :: SysWMmsg
  }
- data KeyboardEventData = KeyboardEventData {
  - keyboardEventWindow :: !(Maybe Window)
  - keyboardEventKeyMotion :: !InputMotion
  - keyboardEventRepeat :: !Bool
  - keyboardEventKeysym :: !Keysym
  }
- data TextEditingEventData = TextEditingEventData {
  - textEditingEventWindow :: !(Maybe Window)
  - textEditingEventText :: !Text
  - textEditingEventStart :: !Int32
  - textEditingEventLength :: !Int32
  }
- data TextInputEventData = TextInputEventData {
  - textInputEventWindow :: !(Maybe Window)
  - textInputEventText :: !Text
  }
- data MouseMotionEventData = MouseMotionEventData {
  - mouseMotionEventWindow :: !(Maybe Window)
  - mouseMotionEventWhich :: !MouseDevice
  - mouseMotionEventState :: ![MouseButton]
  - mouseMotionEventPos :: !(Point V2 Int32)
  - mouseMotionEventRelMotion :: !(V2 Int32)
  }
- data MouseButtonEventData = MouseButtonEventData {
  - mouseButtonEventWindow :: !(Maybe Window)
  - mouseButtonEventMotion :: !InputMotion
  - mouseButtonEventWhich :: !MouseDevice
  - mouseButtonEventButton :: !MouseButton
  - mouseButtonEventClicks :: !Word8
  - mouseButtonEventPos :: !(Point V2 Int32)
  }
- data MouseWheelEventData = MouseWheelEventData {
  - mouseWheelEventWindow :: !(Maybe Window)
  - mouseWheelEventWhich :: !MouseDevice
  - mouseWheelEventPos :: !(V2 Int32)
  - mouseWheelEventDirection :: !MouseScrollDirection
  }
- data JoyAxisEventData = JoyAxisEventData {
  - joyAxisEventWhich :: !JoystickID
  - joyAxisEventAxis :: !Word8
  - joyAxisEventValue :: !Int16
  }
- data JoyBallEventData = JoyBallEventData {
  - joyBallEventWhich :: !JoystickID
  - joyBallEventBall :: !Word8
  - joyBallEventRelMotion :: !(V2 Int16)
  }
- data JoyHatEventData = JoyHatEventData {
  - joyHatEventWhich :: !JoystickID
  - joyHatEventHat :: !Word8
  - joyHatEventValue :: !JoyHatPosition
  }
- data JoyButtonEventData = JoyButtonEventData {
  - joyButtonEventWhich :: !JoystickID
  - joyButtonEventButton :: !Word8
  - joyButtonEventState :: !JoyButtonState
  }
- data JoyDeviceEventData = JoyDeviceEventData {
  - joyDeviceEventConnection :: !JoyDeviceConnection
  - joyDeviceEventWhich :: !JoystickID
  }
- data ControllerAxisEventData = ControllerAxisEventData {
  - controllerAxisEventWhich :: !JoystickID
  - controllerAxisEventAxis :: !ControllerAxis
  - controllerAxisEventValue :: !Int16
  }
- data ControllerButtonEventData = ControllerButtonEventData {
  - controllerButtonEventWhich :: !JoystickID
  - controllerButtonEventButton :: !ControllerButton
  - controllerButtonEventState :: !ControllerButtonState
  }
- data ControllerDeviceEventData = ControllerDeviceEventData {
  - controllerDeviceEventConnection :: !ControllerDeviceConnection
  - controllerDeviceEventWhich :: !JoystickID
  }
- data AudioDeviceEventData = AudioDeviceEventData {
  - audioDeviceEventIsAddition :: !Bool
  - audioDeviceEventWhich :: !Word32
  - audioDeviceEventIsCapture :: !Bool
  }
- data UserEventData = UserEventData {
  - userEventType :: !Word32
  - userEventWindow :: !(Maybe Window)
  - userEventCode :: !Int32
  - userEventData1 :: !(Ptr ())
  - userEventData2 :: !(Ptr ())
  }
- data TouchFingerEventData = TouchFingerEventData {
  - touchFingerEventTouchID :: !TouchID
  - touchFingerEventFingerID :: !FingerID
  - touchFingerEventMotion :: !InputMotion
  - touchFingerEventPos :: !(Point V2 CFloat)
  - touchFingerEventPressure :: !CFloat
  }
- data TouchFingerMotionEventData = TouchFingerMotionEventData {
  - touchFingerMotionEventTouchID :: !TouchID
  - touchFingerMotionEventFingerID :: !FingerID
  - touchFingerMotionEventPos :: !(Point V2 CFloat)
  - touchFingerMotionEventRelMotion :: !(V2 CFloat)
  - touchFingerMotionEventPressure :: !CFloat
  }
- data MultiGestureEventData = MultiGestureEventData {
  - multiGestureEventTouchID :: !TouchID
  - multiGestureEventDTheta :: !CFloat
  - multiGestureEventDDist :: !CFloat
  - multiGestureEventPos :: !(Point V2 CFloat)
  - multiGestureEventNumFingers :: !Word16
  }
- data DollarGestureEventData = DollarGestureEventData {
  - dollarGestureEventTouchID :: !TouchID
  - dollarGestureEventGestureID :: !GestureID
  - dollarGestureEventNumFingers :: !Word32
  - dollarGestureEventError :: !CFloat
  - dollarGestureEventPos :: !(Point V2 CFloat)
  }
- newtype DropEventData = DropEventData {
  - dropEventFile :: CString
  }
- newtype UnknownEventData = UnknownEventData {
  - unknownEventType :: Word32
  }
- data InputMotion
  - = Released
  - | Pressed
- data MouseButton
  - = ButtonLeft
  - | ButtonMiddle
  - | ButtonRight
  - | ButtonX1
  - | ButtonX2
  - | ButtonExtra !Int

# Polling events

pollEvent :: MonadIO m => m (Maybe Event) Source #

Poll for currently pending events. You can only call this function in the OS thread that set the video mode.

pollEvents :: MonadIO m => m [Event] Source #

Clear the event queue by polling for all pending events.

Like `pollEvent` this function should only be called in the OS thread which set the video mode.

mapEvents :: MonadIO m => (Event -> m ()) -> m () Source #

Run a monadic computation, accumulating over all known `Event`s.

This can be useful when used with a state monad, allowing you to fold all events together.

pumpEvents :: MonadIO m => m () Source #

Pump the event loop, gathering events from the input devices.

This function updates the event queue and internal input device state.

This should only be run in the OS thread that initialized the video subsystem, and for extra safety, you should consider only doing those things on the main thread in any case.

`pumpEvents` gathers all the pending input information from devices and places it in the event queue. Without calls to `pumpEvents` no events would ever be placed on the queue. Often the need for calls to `pumpEvents` is hidden from the user since `pollEvent` and `waitEvent` implicitly call `pumpEvents`. However, if you are not polling or waiting for events (e.g. you are filtering them), then you must call `pumpEvents` to force an event queue update.

See `SDL_PumpEvents` for C documentation.

waitEvent :: MonadIO m => m Event Source #

Wait indefinitely for the next available event.

waitEventTimeout Source #

Arguments

:: MonadIO m |
=> CInt | The maximum amount of time to wait, in milliseconds.
-> m (Maybe Event) |

Wait until the specified timeout for the next available amount.

# Registering user events

data RegisteredEventType a Source #

A user defined event structure that has been registered with SDL.

Use `registerEvent`, below, to obtain an instance.

Constructors

RegisteredEventType |

Fields

- pushRegisteredEvent :: a -> IO EventPushResult
- getRegisteredEvent :: Event -> IO (Maybe a)

data RegisteredEventData Source #

A record used to convert between SDL Events and user-defined data structures.

Used for `registerEvent`, below.

Constructors

RegisteredEventData |

Fields

- registeredEventWindow :: !(Maybe Window)

  The associated `Window`.

- registeredEventCode :: !Int32

  User defined event code.

- registeredEventData1 :: !(Ptr ())

  User defined data pointer.

- registeredEventData2 :: !(Ptr ())

  User defined data pointer.

#### Instances

Instances details

Generic RegisteredEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep RegisteredEventData :: Type -> Type Source # Methods from :: RegisteredEventData -> Rep RegisteredEventData x Source # to :: Rep RegisteredEventData x -> RegisteredEventData Source #
Show RegisteredEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> RegisteredEventData -> ShowS Source # show :: RegisteredEventData -> String Source # showList :: [RegisteredEventData] -> ShowS Source #
Eq RegisteredEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: RegisteredEventData -> RegisteredEventData -> Bool Source # (/=) :: RegisteredEventData -> RegisteredEventData -> Bool Source #
Ord RegisteredEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: RegisteredEventData -> RegisteredEventData -> Ordering Source #

(<) :: RegisteredEventData -> RegisteredEventData -> Bool Source #

(<=) :: RegisteredEventData -> RegisteredEventData -> Bool Source #

(>) :: RegisteredEventData -> RegisteredEventData -> Bool Source #

(>=) :: RegisteredEventData -> RegisteredEventData -> Bool Source #

max :: RegisteredEventData -> RegisteredEventData -> RegisteredEventData Source #

min :: RegisteredEventData -> RegisteredEventData -> RegisteredEventData Source #

type Rep RegisteredEventData Source # |

Instance details

Defined in SDL.Event

type Rep RegisteredEventData = D1 ('MetaData "RegisteredEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "RegisteredEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "registeredEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Maybe Window)) :*: S1 ('MetaSel ('Just "registeredEventCode") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int32)) :*: (S1 ('MetaSel ('Just "registeredEventData1") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Ptr ())) :*: S1 ('MetaSel ('Just "registeredEventData2") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Ptr ())))))

data EventPushResult Source #

Possible results of an attempted push of an event to the queue.

Constructors

EventPushSuccess |
EventPushFiltered |
EventPushFailure Text |

#### Instances

Instances details

Data EventPushResult Source # |

Instance details

Defined in SDL.Event

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> EventPushResult -> c EventPushResult Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c EventPushResult Source #

toConstr :: EventPushResult -> Constr Source #

dataTypeOf :: EventPushResult -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c EventPushResult) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c EventPushResult) Source #

gmapT :: (forall b. Data b => b -> b) -> EventPushResult -> EventPushResult Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> EventPushResult -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> EventPushResult -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> EventPushResult -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> EventPushResult -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> EventPushResult -> m EventPushResult Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> EventPushResult -> m EventPushResult Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> EventPushResult -> m EventPushResult Source #

Generic EventPushResult Source # |
Instance details Defined in SDL.Event Associated Types type Rep EventPushResult :: Type -> Type Source # Methods from :: EventPushResult -> Rep EventPushResult x Source # to :: Rep EventPushResult x -> EventPushResult Source #
Read EventPushResult Source # |
Instance details Defined in SDL.Event Methods readsPrec :: Int -> ReadS EventPushResult Source # readList :: ReadS [EventPushResult] Source # readPrec :: ReadPrec EventPushResult Source # readListPrec :: ReadPrec [EventPushResult] Source #
Show EventPushResult Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> EventPushResult -> ShowS Source # show :: EventPushResult -> String Source # showList :: [EventPushResult] -> ShowS Source #
Eq EventPushResult Source # |
Instance details Defined in SDL.Event Methods (==) :: EventPushResult -> EventPushResult -> Bool Source # (/=) :: EventPushResult -> EventPushResult -> Bool Source #
Ord EventPushResult Source # |

Instance details

Defined in SDL.Event

Methods

compare :: EventPushResult -> EventPushResult -> Ordering Source #

(<) :: EventPushResult -> EventPushResult -> Bool Source #

(<=) :: EventPushResult -> EventPushResult -> Bool Source #

(>) :: EventPushResult -> EventPushResult -> Bool Source #

(>=) :: EventPushResult -> EventPushResult -> Bool Source #

max :: EventPushResult -> EventPushResult -> EventPushResult Source #

min :: EventPushResult -> EventPushResult -> EventPushResult Source #

type Rep EventPushResult Source # |

Instance details

Defined in SDL.Event

type Rep EventPushResult = D1 ('MetaData "EventPushResult" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "EventPushSuccess" 'PrefixI 'False) (U1 :: Type -> Type) :+: (C1 ('MetaCons "EventPushFiltered" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "EventPushFailure" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text))))

emptyRegisteredEvent :: RegisteredEventData Source #

A registered event with no associated data.

This is a resonable baseline to modify for converting to `RegisteredEventData`.

registerEvent :: MonadIO m => (RegisteredEventData -> Timestamp -> IO (Maybe a)) -> (a -> IO RegisteredEventData) -> m (Maybe (RegisteredEventType a)) Source #

Register a new event type with SDL.

Provide functions that convert between `UserEventData` and your structure. You can then use `pushRegisteredEvent` to add a custom event of the registered type to the queue, and `getRegisteredEvent` to test for such events in the main loop.

# Watching events

type EventWatchCallback = Event -> IO () Source #

An `EventWatchCallback` can process and respond to an event when it is added to the event queue.

data EventWatch Source #

addEventWatch :: MonadIO m => EventWatchCallback -> m EventWatch Source #

Trigger an `EventWatchCallback` when an event is added to the SDL event queue.

See `https://wiki.libsdl.org/SDL_AddEventWatch` for C documentation.

delEventWatch :: MonadIO m => EventWatch -> m () Source #

Remove an `EventWatch`.

See `https://wiki.libsdl.org/SDL_DelEventWatch` for C documentation.

# Event data

data Event Source #

A single SDL event. This event occurred at `eventTimestamp` and carries data under `eventPayload`.

Constructors

Event |

Fields

- eventTimestamp :: Timestamp

  The time the event occurred.

- eventPayload :: EventPayload

  Data pertaining to this event.

#### Instances

Instances details

Generic Event Source # |
Instance details Defined in SDL.Event Associated Types type Rep Event :: Type -> Type Source # Methods from :: Event -> Rep Event x Source # to :: Rep Event x -> Event Source #
Show Event Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> Event -> ShowS Source # show :: Event -> String Source # showList :: [Event] -> ShowS Source #
Eq Event Source # |
Instance details Defined in SDL.Event Methods (==) :: Event -> Event -> Bool Source # (/=) :: Event -> Event -> Bool Source #
Ord Event Source # |
Instance details Defined in SDL.Event Methods compare :: Event -> Event -> Ordering Source # (<) :: Event -> Event -> Bool Source # (<=) :: Event -> Event -> Bool Source # (>) :: Event -> Event -> Bool Source # (>=) :: Event -> Event -> Bool Source # max :: Event -> Event -> Event Source # min :: Event -> Event -> Event Source #
type Rep Event Source # |

Instance details

Defined in SDL.Event

type Rep Event = D1 ('MetaData "Event" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "Event" 'PrefixI 'True) (S1 ('MetaSel ('Just "eventTimestamp") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Timestamp) :*: S1 ('MetaSel ('Just "eventPayload") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 EventPayload)))

type Timestamp = Word32 Source #

data EventPayload Source #

An enumeration of all possible SDL event types. This data type pairs up event types with their payload, where possible.

Constructors

WindowShownEvent !WindowShownEventData |
WindowHiddenEvent !WindowHiddenEventData |
WindowExposedEvent !WindowExposedEventData |
WindowMovedEvent !WindowMovedEventData |
WindowResizedEvent !WindowResizedEventData |
WindowSizeChangedEvent !WindowSizeChangedEventData |
WindowMinimizedEvent !WindowMinimizedEventData |
WindowMaximizedEvent !WindowMaximizedEventData |
WindowRestoredEvent !WindowRestoredEventData |
WindowGainedMouseFocusEvent !WindowGainedMouseFocusEventData |
WindowLostMouseFocusEvent !WindowLostMouseFocusEventData |
WindowGainedKeyboardFocusEvent !WindowGainedKeyboardFocusEventData |
WindowLostKeyboardFocusEvent !WindowLostKeyboardFocusEventData |
WindowClosedEvent !WindowClosedEventData |
KeyboardEvent !KeyboardEventData |
TextEditingEvent !TextEditingEventData |
TextInputEvent !TextInputEventData |
KeymapChangedEvent |
MouseMotionEvent !MouseMotionEventData |
MouseButtonEvent !MouseButtonEventData |
MouseWheelEvent !MouseWheelEventData |
JoyAxisEvent !JoyAxisEventData |
JoyBallEvent !JoyBallEventData |
JoyHatEvent !JoyHatEventData |
JoyButtonEvent !JoyButtonEventData |
JoyDeviceEvent !JoyDeviceEventData |
ControllerAxisEvent !ControllerAxisEventData |
ControllerButtonEvent !ControllerButtonEventData |
ControllerDeviceEvent !ControllerDeviceEventData |
AudioDeviceEvent !AudioDeviceEventData |
QuitEvent |
UserEvent !UserEventData |
SysWMEvent !SysWMEventData |
TouchFingerEvent !TouchFingerEventData |
TouchFingerMotionEvent !TouchFingerMotionEventData |
MultiGestureEvent !MultiGestureEventData |
DollarGestureEvent !DollarGestureEventData |
DropEvent !DropEventData |
ClipboardUpdateEvent |
UnknownEvent !UnknownEventData |

#### Instances

Instances details

Generic EventPayload Source # |
Instance details Defined in SDL.Event Associated Types type Rep EventPayload :: Type -> Type Source # Methods from :: EventPayload -> Rep EventPayload x Source # to :: Rep EventPayload x -> EventPayload Source #
Show EventPayload Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> EventPayload -> ShowS Source # show :: EventPayload -> String Source # showList :: [EventPayload] -> ShowS Source #
Eq EventPayload Source # |
Instance details Defined in SDL.Event Methods (==) :: EventPayload -> EventPayload -> Bool Source # (/=) :: EventPayload -> EventPayload -> Bool Source #
Ord EventPayload Source # |

Instance details

Defined in SDL.Event

Methods

compare :: EventPayload -> EventPayload -> Ordering Source #

(<) :: EventPayload -> EventPayload -> Bool Source #

(<=) :: EventPayload -> EventPayload -> Bool Source #

(>) :: EventPayload -> EventPayload -> Bool Source #

(>=) :: EventPayload -> EventPayload -> Bool Source #

max :: EventPayload -> EventPayload -> EventPayload Source #

min :: EventPayload -> EventPayload -> EventPayload Source #

type Rep EventPayload Source # |

Instance details

Defined in SDL.Event

type Rep EventPayload = D1 ('MetaData "EventPayload" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (((((C1 ('MetaCons "WindowShownEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowShownEventData)) :+: C1 ('MetaCons "WindowHiddenEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowHiddenEventData))) :+: (C1 ('MetaCons "WindowExposedEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowExposedEventData)) :+: (C1 ('MetaCons "WindowMovedEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowMovedEventData)) :+: C1 ('MetaCons "WindowResizedEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowResizedEventData))))) :+: ((C1 ('MetaCons "WindowSizeChangedEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowSizeChangedEventData)) :+: C1 ('MetaCons "WindowMinimizedEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowMinimizedEventData))) :+: (C1 ('MetaCons "WindowMaximizedEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowMaximizedEventData)) :+: (C1 ('MetaCons "WindowRestoredEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowRestoredEventData)) :+: C1 ('MetaCons "WindowGainedMouseFocusEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowGainedMouseFocusEventData)))))) :+: (((C1 ('MetaCons "WindowLostMouseFocusEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowLostMouseFocusEventData)) :+: C1 ('MetaCons "WindowGainedKeyboardFocusEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowGainedKeyboardFocusEventData))) :+: (C1 ('MetaCons "WindowLostKeyboardFocusEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowLostKeyboardFocusEventData)) :+: (C1 ('MetaCons "WindowClosedEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowClosedEventData)) :+: C1 ('MetaCons "KeyboardEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 KeyboardEventData))))) :+: ((C1 ('MetaCons "TextEditingEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 TextEditingEventData)) :+: C1 ('MetaCons "TextInputEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 TextInputEventData))) :+: (C1 ('MetaCons "KeymapChangedEvent" 'PrefixI 'False) (U1 :: Type -> Type) :+: (C1 ('MetaCons "MouseMotionEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MouseMotionEventData)) :+: C1 ('MetaCons "MouseButtonEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MouseButtonEventData))))))) :+: ((((C1 ('MetaCons "MouseWheelEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MouseWheelEventData)) :+: C1 ('MetaCons "JoyAxisEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoyAxisEventData))) :+: (C1 ('MetaCons "JoyBallEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoyBallEventData)) :+: (C1 ('MetaCons "JoyHatEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoyHatEventData)) :+: C1 ('MetaCons "JoyButtonEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoyButtonEventData))))) :+: ((C1 ('MetaCons "JoyDeviceEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoyDeviceEventData)) :+: C1 ('MetaCons "ControllerAxisEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 ControllerAxisEventData))) :+: (C1 ('MetaCons "ControllerButtonEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 ControllerButtonEventData)) :+: (C1 ('MetaCons "ControllerDeviceEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 ControllerDeviceEventData)) :+: C1 ('MetaCons "AudioDeviceEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 AudioDeviceEventData)))))) :+: (((C1 ('MetaCons "QuitEvent" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "UserEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 UserEventData))) :+: (C1 ('MetaCons "SysWMEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 SysWMEventData)) :+: (C1 ('MetaCons "TouchFingerEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 TouchFingerEventData)) :+: C1 ('MetaCons "TouchFingerMotionEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 TouchFingerMotionEventData))))) :+: ((C1 ('MetaCons "MultiGestureEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MultiGestureEventData)) :+: C1 ('MetaCons "DollarGestureEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 DollarGestureEventData))) :+: (C1 ('MetaCons "DropEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 DropEventData)) :+: (C1 ('MetaCons "ClipboardUpdateEvent" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "UnknownEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 UnknownEventData))))))))

## Window events

newtype WindowShownEventData Source #

A window has been shown.

Constructors

WindowShownEventData |

Fields

- windowShownEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Generic WindowShownEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowShownEventData :: Type -> Type Source # Methods from :: WindowShownEventData -> Rep WindowShownEventData x Source # to :: Rep WindowShownEventData x -> WindowShownEventData Source #
Show WindowShownEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowShownEventData -> ShowS Source # show :: WindowShownEventData -> String Source # showList :: [WindowShownEventData] -> ShowS Source #
Eq WindowShownEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowShownEventData -> WindowShownEventData -> Bool Source # (/=) :: WindowShownEventData -> WindowShownEventData -> Bool Source #
Ord WindowShownEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowShownEventData -> WindowShownEventData -> Ordering Source #

(<) :: WindowShownEventData -> WindowShownEventData -> Bool Source #

(<=) :: WindowShownEventData -> WindowShownEventData -> Bool Source #

(>) :: WindowShownEventData -> WindowShownEventData -> Bool Source #

(>=) :: WindowShownEventData -> WindowShownEventData -> Bool Source #

max :: WindowShownEventData -> WindowShownEventData -> WindowShownEventData Source #

min :: WindowShownEventData -> WindowShownEventData -> WindowShownEventData Source #

type Rep WindowShownEventData Source # |
Instance details Defined in SDL.Event type Rep WindowShownEventData = D1 ('MetaData "WindowShownEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'True) (C1 ('MetaCons "WindowShownEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowShownEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowHiddenEventData Source #

A window has been hidden.

Constructors

WindowHiddenEventData |

Fields

- windowHiddenEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Generic WindowHiddenEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowHiddenEventData :: Type -> Type Source # Methods from :: WindowHiddenEventData -> Rep WindowHiddenEventData x Source # to :: Rep WindowHiddenEventData x -> WindowHiddenEventData Source #
Show WindowHiddenEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowHiddenEventData -> ShowS Source # show :: WindowHiddenEventData -> String Source # showList :: [WindowHiddenEventData] -> ShowS Source #
Eq WindowHiddenEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowHiddenEventData -> WindowHiddenEventData -> Bool Source # (/=) :: WindowHiddenEventData -> WindowHiddenEventData -> Bool Source #
Ord WindowHiddenEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowHiddenEventData -> WindowHiddenEventData -> Ordering Source #

(<) :: WindowHiddenEventData -> WindowHiddenEventData -> Bool Source #

(<=) :: WindowHiddenEventData -> WindowHiddenEventData -> Bool Source #

(>) :: WindowHiddenEventData -> WindowHiddenEventData -> Bool Source #

(>=) :: WindowHiddenEventData -> WindowHiddenEventData -> Bool Source #

max :: WindowHiddenEventData -> WindowHiddenEventData -> WindowHiddenEventData Source #

min :: WindowHiddenEventData -> WindowHiddenEventData -> WindowHiddenEventData Source #

type Rep WindowHiddenEventData Source # |
Instance details Defined in SDL.Event type Rep WindowHiddenEventData = D1 ('MetaData "WindowHiddenEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'True) (C1 ('MetaCons "WindowHiddenEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowHiddenEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowExposedEventData Source #

A part of a window has been exposed - where exposure means to become visible (for example, an overlapping window no longer overlaps with the window).

Constructors

WindowExposedEventData |

Fields

- windowExposedEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Generic WindowExposedEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowExposedEventData :: Type -> Type Source # Methods from :: WindowExposedEventData -> Rep WindowExposedEventData x Source # to :: Rep WindowExposedEventData x -> WindowExposedEventData Source #
Show WindowExposedEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowExposedEventData -> ShowS Source # show :: WindowExposedEventData -> String Source # showList :: [WindowExposedEventData] -> ShowS Source #
Eq WindowExposedEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowExposedEventData -> WindowExposedEventData -> Bool Source # (/=) :: WindowExposedEventData -> WindowExposedEventData -> Bool Source #
Ord WindowExposedEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowExposedEventData -> WindowExposedEventData -> Ordering Source #

(<) :: WindowExposedEventData -> WindowExposedEventData -> Bool Source #

(<=) :: WindowExposedEventData -> WindowExposedEventData -> Bool Source #

(>) :: WindowExposedEventData -> WindowExposedEventData -> Bool Source #

(>=) :: WindowExposedEventData -> WindowExposedEventData -> Bool Source #

max :: WindowExposedEventData -> WindowExposedEventData -> WindowExposedEventData Source #

min :: WindowExposedEventData -> WindowExposedEventData -> WindowExposedEventData Source #

type Rep WindowExposedEventData Source # |
Instance details Defined in SDL.Event type Rep WindowExposedEventData = D1 ('MetaData "WindowExposedEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'True) (C1 ('MetaCons "WindowExposedEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowExposedEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

data WindowMovedEventData Source #

A `Window` has been moved.

Constructors

WindowMovedEventData |

Fields

- windowMovedEventWindow :: !Window

  The associated `Window`.

- windowMovedEventPosition :: !(Point V2 Int32)

  The new position of the `Window`.

#### Instances

Instances details

Generic WindowMovedEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowMovedEventData :: Type -> Type Source # Methods from :: WindowMovedEventData -> Rep WindowMovedEventData x Source # to :: Rep WindowMovedEventData x -> WindowMovedEventData Source #
Show WindowMovedEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowMovedEventData -> ShowS Source # show :: WindowMovedEventData -> String Source # showList :: [WindowMovedEventData] -> ShowS Source #
Eq WindowMovedEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowMovedEventData -> WindowMovedEventData -> Bool Source # (/=) :: WindowMovedEventData -> WindowMovedEventData -> Bool Source #
Ord WindowMovedEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowMovedEventData -> WindowMovedEventData -> Ordering Source #

(<) :: WindowMovedEventData -> WindowMovedEventData -> Bool Source #

(<=) :: WindowMovedEventData -> WindowMovedEventData -> Bool Source #

(>) :: WindowMovedEventData -> WindowMovedEventData -> Bool Source #

(>=) :: WindowMovedEventData -> WindowMovedEventData -> Bool Source #

max :: WindowMovedEventData -> WindowMovedEventData -> WindowMovedEventData Source #

min :: WindowMovedEventData -> WindowMovedEventData -> WindowMovedEventData Source #

type Rep WindowMovedEventData Source # |

Instance details

Defined in SDL.Event

type Rep WindowMovedEventData = D1 ('MetaData "WindowMovedEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "WindowMovedEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowMovedEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Window) :*: S1 ('MetaSel ('Just "windowMovedEventPosition") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Point V2 Int32))))

data WindowResizedEventData Source #

Window has been resized. This is event is always preceded by `WindowSizeChangedEvent`.

Constructors

WindowResizedEventData |

Fields

- windowResizedEventWindow :: !Window

  The associated `Window`.

- windowResizedEventSize :: !(V2 Int32)

  The new size of the `Window`.

#### Instances

Instances details

Generic WindowResizedEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowResizedEventData :: Type -> Type Source # Methods from :: WindowResizedEventData -> Rep WindowResizedEventData x Source # to :: Rep WindowResizedEventData x -> WindowResizedEventData Source #
Show WindowResizedEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowResizedEventData -> ShowS Source # show :: WindowResizedEventData -> String Source # showList :: [WindowResizedEventData] -> ShowS Source #
Eq WindowResizedEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowResizedEventData -> WindowResizedEventData -> Bool Source # (/=) :: WindowResizedEventData -> WindowResizedEventData -> Bool Source #
Ord WindowResizedEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowResizedEventData -> WindowResizedEventData -> Ordering Source #

(<) :: WindowResizedEventData -> WindowResizedEventData -> Bool Source #

(<=) :: WindowResizedEventData -> WindowResizedEventData -> Bool Source #

(>) :: WindowResizedEventData -> WindowResizedEventData -> Bool Source #

(>=) :: WindowResizedEventData -> WindowResizedEventData -> Bool Source #

max :: WindowResizedEventData -> WindowResizedEventData -> WindowResizedEventData Source #

min :: WindowResizedEventData -> WindowResizedEventData -> WindowResizedEventData Source #

type Rep WindowResizedEventData Source # |

Instance details

Defined in SDL.Event

type Rep WindowResizedEventData = D1 ('MetaData "WindowResizedEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "WindowResizedEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowResizedEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Window) :*: S1 ('MetaSel ('Just "windowResizedEventSize") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (V2 Int32))))

data WindowSizeChangedEventData Source #

The window size has changed, either as a result of an API call or through the system or user changing the window size; this event is followed by `WindowResizedEvent` if the size was changed by an external event, i.e. the user or the window manager.

Constructors

WindowSizeChangedEventData |

Fields

- windowSizeChangedEventWindow :: !Window

  The associated `Window`.

- windowSizeChangedEventSize :: !(V2 Int32)

  The new size of the `Window`.

#### Instances

Instances details

Generic WindowSizeChangedEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowSizeChangedEventData :: Type -> Type Source # Methods from :: WindowSizeChangedEventData -> Rep WindowSizeChangedEventData x Source # to :: Rep WindowSizeChangedEventData x -> WindowSizeChangedEventData Source #
Show WindowSizeChangedEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowSizeChangedEventData -> ShowS Source # show :: WindowSizeChangedEventData -> String Source # showList :: [WindowSizeChangedEventData] -> ShowS Source #
Eq WindowSizeChangedEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> Bool Source # (/=) :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> Bool Source #
Ord WindowSizeChangedEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> Ordering Source #

(<) :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> Bool Source #

(<=) :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> Bool Source #

(>) :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> Bool Source #

(>=) :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> Bool Source #

max :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> WindowSizeChangedEventData Source #

min :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> WindowSizeChangedEventData Source #

type Rep WindowSizeChangedEventData Source # |

Instance details

Defined in SDL.Event

type Rep WindowSizeChangedEventData = D1 ('MetaData "WindowSizeChangedEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "WindowSizeChangedEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowSizeChangedEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Window) :*: S1 ('MetaSel ('Just "windowSizeChangedEventSize") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (V2 Int32))))

newtype WindowMinimizedEventData Source #

The window has been minimized.

Constructors

WindowMinimizedEventData |

Fields

- windowMinimizedEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Generic WindowMinimizedEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowMinimizedEventData :: Type -> Type Source # Methods from :: WindowMinimizedEventData -> Rep WindowMinimizedEventData x Source # to :: Rep WindowMinimizedEventData x -> WindowMinimizedEventData Source #
Show WindowMinimizedEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowMinimizedEventData -> ShowS Source # show :: WindowMinimizedEventData -> String Source # showList :: [WindowMinimizedEventData] -> ShowS Source #
Eq WindowMinimizedEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowMinimizedEventData -> WindowMinimizedEventData -> Bool Source # (/=) :: WindowMinimizedEventData -> WindowMinimizedEventData -> Bool Source #
Ord WindowMinimizedEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowMinimizedEventData -> WindowMinimizedEventData -> Ordering Source #

(<) :: WindowMinimizedEventData -> WindowMinimizedEventData -> Bool Source #

(<=) :: WindowMinimizedEventData -> WindowMinimizedEventData -> Bool Source #

(>) :: WindowMinimizedEventData -> WindowMinimizedEventData -> Bool Source #

(>=) :: WindowMinimizedEventData -> WindowMinimizedEventData -> Bool Source #

max :: WindowMinimizedEventData -> WindowMinimizedEventData -> WindowMinimizedEventData Source #

min :: WindowMinimizedEventData -> WindowMinimizedEventData -> WindowMinimizedEventData Source #

type Rep WindowMinimizedEventData Source # |
Instance details Defined in SDL.Event type Rep WindowMinimizedEventData = D1 ('MetaData "WindowMinimizedEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'True) (C1 ('MetaCons "WindowMinimizedEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowMinimizedEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowMaximizedEventData Source #

The window has been maximized.

Constructors

WindowMaximizedEventData |

Fields

- windowMaximizedEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Generic WindowMaximizedEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowMaximizedEventData :: Type -> Type Source # Methods from :: WindowMaximizedEventData -> Rep WindowMaximizedEventData x Source # to :: Rep WindowMaximizedEventData x -> WindowMaximizedEventData Source #
Show WindowMaximizedEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowMaximizedEventData -> ShowS Source # show :: WindowMaximizedEventData -> String Source # showList :: [WindowMaximizedEventData] -> ShowS Source #
Eq WindowMaximizedEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowMaximizedEventData -> WindowMaximizedEventData -> Bool Source # (/=) :: WindowMaximizedEventData -> WindowMaximizedEventData -> Bool Source #
Ord WindowMaximizedEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowMaximizedEventData -> WindowMaximizedEventData -> Ordering Source #

(<) :: WindowMaximizedEventData -> WindowMaximizedEventData -> Bool Source #

(<=) :: WindowMaximizedEventData -> WindowMaximizedEventData -> Bool Source #

(>) :: WindowMaximizedEventData -> WindowMaximizedEventData -> Bool Source #

(>=) :: WindowMaximizedEventData -> WindowMaximizedEventData -> Bool Source #

max :: WindowMaximizedEventData -> WindowMaximizedEventData -> WindowMaximizedEventData Source #

min :: WindowMaximizedEventData -> WindowMaximizedEventData -> WindowMaximizedEventData Source #

type Rep WindowMaximizedEventData Source # |
Instance details Defined in SDL.Event type Rep WindowMaximizedEventData = D1 ('MetaData "WindowMaximizedEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'True) (C1 ('MetaCons "WindowMaximizedEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowMaximizedEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowRestoredEventData Source #

The window has been restored to normal size and position.

Constructors

WindowRestoredEventData |

Fields

- windowRestoredEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Generic WindowRestoredEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowRestoredEventData :: Type -> Type Source # Methods from :: WindowRestoredEventData -> Rep WindowRestoredEventData x Source # to :: Rep WindowRestoredEventData x -> WindowRestoredEventData Source #
Show WindowRestoredEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowRestoredEventData -> ShowS Source # show :: WindowRestoredEventData -> String Source # showList :: [WindowRestoredEventData] -> ShowS Source #
Eq WindowRestoredEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowRestoredEventData -> WindowRestoredEventData -> Bool Source # (/=) :: WindowRestoredEventData -> WindowRestoredEventData -> Bool Source #
Ord WindowRestoredEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowRestoredEventData -> WindowRestoredEventData -> Ordering Source #

(<) :: WindowRestoredEventData -> WindowRestoredEventData -> Bool Source #

(<=) :: WindowRestoredEventData -> WindowRestoredEventData -> Bool Source #

(>) :: WindowRestoredEventData -> WindowRestoredEventData -> Bool Source #

(>=) :: WindowRestoredEventData -> WindowRestoredEventData -> Bool Source #

max :: WindowRestoredEventData -> WindowRestoredEventData -> WindowRestoredEventData Source #

min :: WindowRestoredEventData -> WindowRestoredEventData -> WindowRestoredEventData Source #

type Rep WindowRestoredEventData Source # |
Instance details Defined in SDL.Event type Rep WindowRestoredEventData = D1 ('MetaData "WindowRestoredEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'True) (C1 ('MetaCons "WindowRestoredEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowRestoredEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowGainedMouseFocusEventData Source #

The window has gained mouse focus.

Constructors

WindowGainedMouseFocusEventData |

Fields

- windowGainedMouseFocusEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Generic WindowGainedMouseFocusEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowGainedMouseFocusEventData :: Type -> Type Source # Methods from :: WindowGainedMouseFocusEventData -> Rep WindowGainedMouseFocusEventData x Source # to :: Rep WindowGainedMouseFocusEventData x -> WindowGainedMouseFocusEventData Source #
Show WindowGainedMouseFocusEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowGainedMouseFocusEventData -> ShowS Source # show :: WindowGainedMouseFocusEventData -> String Source # showList :: [WindowGainedMouseFocusEventData] -> ShowS Source #
Eq WindowGainedMouseFocusEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> Bool Source # (/=) :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> Bool Source #
Ord WindowGainedMouseFocusEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> Ordering Source #

(<) :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> Bool Source #

(<=) :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> Bool Source #

(>) :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> Bool Source #

(>=) :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> Bool Source #

max :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData Source #

min :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData Source #

type Rep WindowGainedMouseFocusEventData Source # |
Instance details Defined in SDL.Event type Rep WindowGainedMouseFocusEventData = D1 ('MetaData "WindowGainedMouseFocusEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'True) (C1 ('MetaCons "WindowGainedMouseFocusEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowGainedMouseFocusEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowLostMouseFocusEventData Source #

The window has lost mouse focus.

Constructors

WindowLostMouseFocusEventData |

Fields

- windowLostMouseFocusEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Generic WindowLostMouseFocusEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowLostMouseFocusEventData :: Type -> Type Source # Methods from :: WindowLostMouseFocusEventData -> Rep WindowLostMouseFocusEventData x Source # to :: Rep WindowLostMouseFocusEventData x -> WindowLostMouseFocusEventData Source #
Show WindowLostMouseFocusEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowLostMouseFocusEventData -> ShowS Source # show :: WindowLostMouseFocusEventData -> String Source # showList :: [WindowLostMouseFocusEventData] -> ShowS Source #
Eq WindowLostMouseFocusEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> Bool Source # (/=) :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> Bool Source #
Ord WindowLostMouseFocusEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> Ordering Source #

(<) :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> Bool Source #

(<=) :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> Bool Source #

(>) :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> Bool Source #

(>=) :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> Bool Source #

max :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData Source #

min :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData Source #

type Rep WindowLostMouseFocusEventData Source # |
Instance details Defined in SDL.Event type Rep WindowLostMouseFocusEventData = D1 ('MetaData "WindowLostMouseFocusEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'True) (C1 ('MetaCons "WindowLostMouseFocusEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowLostMouseFocusEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowGainedKeyboardFocusEventData Source #

The window has gained keyboard focus.

Constructors

WindowGainedKeyboardFocusEventData |

Fields

- windowGainedKeyboardFocusEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Generic WindowGainedKeyboardFocusEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowGainedKeyboardFocusEventData :: Type -> Type Source # Methods from :: WindowGainedKeyboardFocusEventData -> Rep WindowGainedKeyboardFocusEventData x Source # to :: Rep WindowGainedKeyboardFocusEventData x -> WindowGainedKeyboardFocusEventData Source #
Show WindowGainedKeyboardFocusEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowGainedKeyboardFocusEventData -> ShowS Source # show :: WindowGainedKeyboardFocusEventData -> String Source # showList :: [WindowGainedKeyboardFocusEventData] -> ShowS Source #
Eq WindowGainedKeyboardFocusEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> Bool Source # (/=) :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> Bool Source #
Ord WindowGainedKeyboardFocusEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> Ordering Source #

(<) :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> Bool Source #

(<=) :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> Bool Source #

(>) :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> Bool Source #

(>=) :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> Bool Source #

max :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData Source #

min :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData Source #

type Rep WindowGainedKeyboardFocusEventData Source # |
Instance details Defined in SDL.Event type Rep WindowGainedKeyboardFocusEventData = D1 ('MetaData "WindowGainedKeyboardFocusEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'True) (C1 ('MetaCons "WindowGainedKeyboardFocusEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowGainedKeyboardFocusEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowLostKeyboardFocusEventData Source #

The window has lost keyboard focus.

Constructors

WindowLostKeyboardFocusEventData |

Fields

- windowLostKeyboardFocusEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Generic WindowLostKeyboardFocusEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowLostKeyboardFocusEventData :: Type -> Type Source # Methods from :: WindowLostKeyboardFocusEventData -> Rep WindowLostKeyboardFocusEventData x Source # to :: Rep WindowLostKeyboardFocusEventData x -> WindowLostKeyboardFocusEventData Source #
Show WindowLostKeyboardFocusEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowLostKeyboardFocusEventData -> ShowS Source # show :: WindowLostKeyboardFocusEventData -> String Source # showList :: [WindowLostKeyboardFocusEventData] -> ShowS Source #
Eq WindowLostKeyboardFocusEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> Bool Source # (/=) :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> Bool Source #
Ord WindowLostKeyboardFocusEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> Ordering Source #

(<) :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> Bool Source #

(<=) :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> Bool Source #

(>) :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> Bool Source #

(>=) :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> Bool Source #

max :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData Source #

min :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData Source #

type Rep WindowLostKeyboardFocusEventData Source # |
Instance details Defined in SDL.Event type Rep WindowLostKeyboardFocusEventData = D1 ('MetaData "WindowLostKeyboardFocusEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'True) (C1 ('MetaCons "WindowLostKeyboardFocusEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowLostKeyboardFocusEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowClosedEventData Source #

The window manager requests that the window be closed.

Constructors

WindowClosedEventData |

Fields

- windowClosedEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Generic WindowClosedEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowClosedEventData :: Type -> Type Source # Methods from :: WindowClosedEventData -> Rep WindowClosedEventData x Source # to :: Rep WindowClosedEventData x -> WindowClosedEventData Source #
Show WindowClosedEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowClosedEventData -> ShowS Source # show :: WindowClosedEventData -> String Source # showList :: [WindowClosedEventData] -> ShowS Source #
Eq WindowClosedEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowClosedEventData -> WindowClosedEventData -> Bool Source # (/=) :: WindowClosedEventData -> WindowClosedEventData -> Bool Source #
Ord WindowClosedEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowClosedEventData -> WindowClosedEventData -> Ordering Source #

(<) :: WindowClosedEventData -> WindowClosedEventData -> Bool Source #

(<=) :: WindowClosedEventData -> WindowClosedEventData -> Bool Source #

(>) :: WindowClosedEventData -> WindowClosedEventData -> Bool Source #

(>=) :: WindowClosedEventData -> WindowClosedEventData -> Bool Source #

max :: WindowClosedEventData -> WindowClosedEventData -> WindowClosedEventData Source #

min :: WindowClosedEventData -> WindowClosedEventData -> WindowClosedEventData Source #

type Rep WindowClosedEventData Source # |
Instance details Defined in SDL.Event type Rep WindowClosedEventData = D1 ('MetaData "WindowClosedEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'True) (C1 ('MetaCons "WindowClosedEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowClosedEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype SysWMEventData Source #

A video driver dependent system event

Constructors

SysWMEventData |

Fields

- sysWMEventMsg :: SysWMmsg

#### Instances

Instances details

Generic SysWMEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep SysWMEventData :: Type -> Type Source # Methods from :: SysWMEventData -> Rep SysWMEventData x Source # to :: Rep SysWMEventData x -> SysWMEventData Source #
Show SysWMEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> SysWMEventData -> ShowS Source # show :: SysWMEventData -> String Source # showList :: [SysWMEventData] -> ShowS Source #
Eq SysWMEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: SysWMEventData -> SysWMEventData -> Bool Source # (/=) :: SysWMEventData -> SysWMEventData -> Bool Source #
Ord SysWMEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: SysWMEventData -> SysWMEventData -> Ordering Source #

(<) :: SysWMEventData -> SysWMEventData -> Bool Source #

(<=) :: SysWMEventData -> SysWMEventData -> Bool Source #

(>) :: SysWMEventData -> SysWMEventData -> Bool Source #

(>=) :: SysWMEventData -> SysWMEventData -> Bool Source #

max :: SysWMEventData -> SysWMEventData -> SysWMEventData Source #

min :: SysWMEventData -> SysWMEventData -> SysWMEventData Source #

type Rep SysWMEventData Source # |
Instance details Defined in SDL.Event type Rep SysWMEventData = D1 ('MetaData "SysWMEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'True) (C1 ('MetaCons "SysWMEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "sysWMEventMsg") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SysWMmsg)))

## Keyboard events

data KeyboardEventData Source #

A keyboard key has been pressed or released.

Constructors

KeyboardEventData |

Fields

- keyboardEventWindow :: !(Maybe Window)

  The `Window` with keyboard focus, if any.

- keyboardEventKeyMotion :: !InputMotion

  Whether the key was pressed or released.

- keyboardEventRepeat :: !Bool

  `True` if this is a repeating key press from the user holding the key down.

- keyboardEventKeysym :: !Keysym

  A description of the key that this event pertains to.

#### Instances

Instances details

Generic KeyboardEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep KeyboardEventData :: Type -> Type Source # Methods from :: KeyboardEventData -> Rep KeyboardEventData x Source # to :: Rep KeyboardEventData x -> KeyboardEventData Source #
Show KeyboardEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> KeyboardEventData -> ShowS Source # show :: KeyboardEventData -> String Source # showList :: [KeyboardEventData] -> ShowS Source #
Eq KeyboardEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: KeyboardEventData -> KeyboardEventData -> Bool Source # (/=) :: KeyboardEventData -> KeyboardEventData -> Bool Source #
Ord KeyboardEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: KeyboardEventData -> KeyboardEventData -> Ordering Source #

(<) :: KeyboardEventData -> KeyboardEventData -> Bool Source #

(<=) :: KeyboardEventData -> KeyboardEventData -> Bool Source #

(>) :: KeyboardEventData -> KeyboardEventData -> Bool Source #

(>=) :: KeyboardEventData -> KeyboardEventData -> Bool Source #

max :: KeyboardEventData -> KeyboardEventData -> KeyboardEventData Source #

min :: KeyboardEventData -> KeyboardEventData -> KeyboardEventData Source #

type Rep KeyboardEventData Source # |

Instance details

Defined in SDL.Event

type Rep KeyboardEventData = D1 ('MetaData "KeyboardEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "KeyboardEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "keyboardEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Maybe Window)) :*: S1 ('MetaSel ('Just "keyboardEventKeyMotion") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 InputMotion)) :*: (S1 ('MetaSel ('Just "keyboardEventRepeat") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Bool) :*: S1 ('MetaSel ('Just "keyboardEventKeysym") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Keysym))))

data TextEditingEventData Source #

Keyboard text editing event information.

Constructors

TextEditingEventData |

Fields

- textEditingEventWindow :: !(Maybe Window)

  The `Window` with keyboard focus, if any.

- textEditingEventText :: !Text

  The editing text.

- textEditingEventStart :: !Int32

  The location to begin editing from.

- textEditingEventLength :: !Int32

  The number of characters to edit from the start point.

#### Instances

Instances details

Generic TextEditingEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep TextEditingEventData :: Type -> Type Source # Methods from :: TextEditingEventData -> Rep TextEditingEventData x Source # to :: Rep TextEditingEventData x -> TextEditingEventData Source #
Show TextEditingEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> TextEditingEventData -> ShowS Source # show :: TextEditingEventData -> String Source # showList :: [TextEditingEventData] -> ShowS Source #
Eq TextEditingEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: TextEditingEventData -> TextEditingEventData -> Bool Source # (/=) :: TextEditingEventData -> TextEditingEventData -> Bool Source #
Ord TextEditingEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: TextEditingEventData -> TextEditingEventData -> Ordering Source #

(<) :: TextEditingEventData -> TextEditingEventData -> Bool Source #

(<=) :: TextEditingEventData -> TextEditingEventData -> Bool Source #

(>) :: TextEditingEventData -> TextEditingEventData -> Bool Source #

(>=) :: TextEditingEventData -> TextEditingEventData -> Bool Source #

max :: TextEditingEventData -> TextEditingEventData -> TextEditingEventData Source #

min :: TextEditingEventData -> TextEditingEventData -> TextEditingEventData Source #

type Rep TextEditingEventData Source # |

Instance details

Defined in SDL.Event

type Rep TextEditingEventData = D1 ('MetaData "TextEditingEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "TextEditingEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "textEditingEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Maybe Window)) :*: S1 ('MetaSel ('Just "textEditingEventText") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Text)) :*: (S1 ('MetaSel ('Just "textEditingEventStart") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int32) :*: S1 ('MetaSel ('Just "textEditingEventLength") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int32))))

data TextInputEventData Source #

Keyboard text input event information.

Constructors

TextInputEventData |

Fields

- textInputEventWindow :: !(Maybe Window)

  The `Window` with keyboard focus, if any.

- textInputEventText :: !Text

  The input text.

#### Instances

Instances details

Generic TextInputEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep TextInputEventData :: Type -> Type Source # Methods from :: TextInputEventData -> Rep TextInputEventData x Source # to :: Rep TextInputEventData x -> TextInputEventData Source #
Show TextInputEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> TextInputEventData -> ShowS Source # show :: TextInputEventData -> String Source # showList :: [TextInputEventData] -> ShowS Source #
Eq TextInputEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: TextInputEventData -> TextInputEventData -> Bool Source # (/=) :: TextInputEventData -> TextInputEventData -> Bool Source #
Ord TextInputEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: TextInputEventData -> TextInputEventData -> Ordering Source #

(<) :: TextInputEventData -> TextInputEventData -> Bool Source #

(<=) :: TextInputEventData -> TextInputEventData -> Bool Source #

(>) :: TextInputEventData -> TextInputEventData -> Bool Source #

(>=) :: TextInputEventData -> TextInputEventData -> Bool Source #

max :: TextInputEventData -> TextInputEventData -> TextInputEventData Source #

min :: TextInputEventData -> TextInputEventData -> TextInputEventData Source #

type Rep TextInputEventData Source # |

Instance details

Defined in SDL.Event

type Rep TextInputEventData = D1 ('MetaData "TextInputEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "TextInputEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "textInputEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Maybe Window)) :*: S1 ('MetaSel ('Just "textInputEventText") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Text)))

## Mouse events

data MouseMotionEventData Source #

A mouse or pointer device was moved.

Constructors

MouseMotionEventData |

Fields

- mouseMotionEventWindow :: !(Maybe Window)

  The `Window` with mouse focus, if any.

- mouseMotionEventWhich :: !MouseDevice

  The `MouseDevice` that was moved.

- mouseMotionEventState :: ![MouseButton]

  A collection of `MouseButton`s that are currently held down.

- mouseMotionEventPos :: !(Point V2 Int32)

  The new position of the mouse.

- mouseMotionEventRelMotion :: !(V2 Int32)

  The relative mouse motion of the mouse.

#### Instances

Instances details

Generic MouseMotionEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep MouseMotionEventData :: Type -> Type Source # Methods from :: MouseMotionEventData -> Rep MouseMotionEventData x Source # to :: Rep MouseMotionEventData x -> MouseMotionEventData Source #
Show MouseMotionEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> MouseMotionEventData -> ShowS Source # show :: MouseMotionEventData -> String Source # showList :: [MouseMotionEventData] -> ShowS Source #
Eq MouseMotionEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: MouseMotionEventData -> MouseMotionEventData -> Bool Source # (/=) :: MouseMotionEventData -> MouseMotionEventData -> Bool Source #
Ord MouseMotionEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: MouseMotionEventData -> MouseMotionEventData -> Ordering Source #

(<) :: MouseMotionEventData -> MouseMotionEventData -> Bool Source #

(<=) :: MouseMotionEventData -> MouseMotionEventData -> Bool Source #

(>) :: MouseMotionEventData -> MouseMotionEventData -> Bool Source #

(>=) :: MouseMotionEventData -> MouseMotionEventData -> Bool Source #

max :: MouseMotionEventData -> MouseMotionEventData -> MouseMotionEventData Source #

min :: MouseMotionEventData -> MouseMotionEventData -> MouseMotionEventData Source #

type Rep MouseMotionEventData Source # |

Instance details

Defined in SDL.Event

type Rep MouseMotionEventData = D1 ('MetaData "MouseMotionEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "MouseMotionEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "mouseMotionEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Maybe Window)) :*: S1 ('MetaSel ('Just "mouseMotionEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MouseDevice)) :*: (S1 ('MetaSel ('Just "mouseMotionEventState") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 [MouseButton]) :*: (S1 ('MetaSel ('Just "mouseMotionEventPos") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Point V2 Int32)) :*: S1 ('MetaSel ('Just "mouseMotionEventRelMotion") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (V2 Int32))))))

data MouseButtonEventData Source #

A mouse or pointer device button was pressed or released.

Constructors

MouseButtonEventData |

Fields

- mouseButtonEventWindow :: !(Maybe Window)

  The `Window` with mouse focus, if any.

- mouseButtonEventMotion :: !InputMotion

  Whether the button was pressed or released.

- mouseButtonEventWhich :: !MouseDevice

  The `MouseDevice` whose button was pressed or released.

- mouseButtonEventButton :: !MouseButton

  The button that was pressed or released.

- mouseButtonEventClicks :: !Word8

  The amount of clicks. 1 for a single-click, 2 for a double-click, etc.

- mouseButtonEventPos :: !(Point V2 Int32)

  The coordinates of the mouse click.

#### Instances

Instances details

Generic MouseButtonEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep MouseButtonEventData :: Type -> Type Source # Methods from :: MouseButtonEventData -> Rep MouseButtonEventData x Source # to :: Rep MouseButtonEventData x -> MouseButtonEventData Source #
Show MouseButtonEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> MouseButtonEventData -> ShowS Source # show :: MouseButtonEventData -> String Source # showList :: [MouseButtonEventData] -> ShowS Source #
Eq MouseButtonEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: MouseButtonEventData -> MouseButtonEventData -> Bool Source # (/=) :: MouseButtonEventData -> MouseButtonEventData -> Bool Source #
Ord MouseButtonEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: MouseButtonEventData -> MouseButtonEventData -> Ordering Source #

(<) :: MouseButtonEventData -> MouseButtonEventData -> Bool Source #

(<=) :: MouseButtonEventData -> MouseButtonEventData -> Bool Source #

(>) :: MouseButtonEventData -> MouseButtonEventData -> Bool Source #

(>=) :: MouseButtonEventData -> MouseButtonEventData -> Bool Source #

max :: MouseButtonEventData -> MouseButtonEventData -> MouseButtonEventData Source #

min :: MouseButtonEventData -> MouseButtonEventData -> MouseButtonEventData Source #

type Rep MouseButtonEventData Source # |

Instance details

Defined in SDL.Event

type Rep MouseButtonEventData = D1 ('MetaData "MouseButtonEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "MouseButtonEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "mouseButtonEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Maybe Window)) :*: (S1 ('MetaSel ('Just "mouseButtonEventMotion") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 InputMotion) :*: S1 ('MetaSel ('Just "mouseButtonEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MouseDevice))) :*: (S1 ('MetaSel ('Just "mouseButtonEventButton") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MouseButton) :*: (S1 ('MetaSel ('Just "mouseButtonEventClicks") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word8) :*: S1 ('MetaSel ('Just "mouseButtonEventPos") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Point V2 Int32))))))

data MouseWheelEventData Source #

Mouse wheel event information.

Constructors

MouseWheelEventData |

Fields

- mouseWheelEventWindow :: !(Maybe Window)

  The `Window` with mouse focus, if any.

- mouseWheelEventWhich :: !MouseDevice

  The `MouseDevice` whose wheel was scrolled.

- mouseWheelEventPos :: !(V2 Int32)

  The amount scrolled.

- mouseWheelEventDirection :: !MouseScrollDirection

  The scroll direction mode.

#### Instances

Instances details

Generic MouseWheelEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep MouseWheelEventData :: Type -> Type Source # Methods from :: MouseWheelEventData -> Rep MouseWheelEventData x Source # to :: Rep MouseWheelEventData x -> MouseWheelEventData Source #
Show MouseWheelEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> MouseWheelEventData -> ShowS Source # show :: MouseWheelEventData -> String Source # showList :: [MouseWheelEventData] -> ShowS Source #
Eq MouseWheelEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: MouseWheelEventData -> MouseWheelEventData -> Bool Source # (/=) :: MouseWheelEventData -> MouseWheelEventData -> Bool Source #
Ord MouseWheelEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: MouseWheelEventData -> MouseWheelEventData -> Ordering Source #

(<) :: MouseWheelEventData -> MouseWheelEventData -> Bool Source #

(<=) :: MouseWheelEventData -> MouseWheelEventData -> Bool Source #

(>) :: MouseWheelEventData -> MouseWheelEventData -> Bool Source #

(>=) :: MouseWheelEventData -> MouseWheelEventData -> Bool Source #

max :: MouseWheelEventData -> MouseWheelEventData -> MouseWheelEventData Source #

min :: MouseWheelEventData -> MouseWheelEventData -> MouseWheelEventData Source #

type Rep MouseWheelEventData Source # |

Instance details

Defined in SDL.Event

type Rep MouseWheelEventData = D1 ('MetaData "MouseWheelEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "MouseWheelEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "mouseWheelEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Maybe Window)) :*: S1 ('MetaSel ('Just "mouseWheelEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MouseDevice)) :*: (S1 ('MetaSel ('Just "mouseWheelEventPos") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (V2 Int32)) :*: S1 ('MetaSel ('Just "mouseWheelEventDirection") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MouseScrollDirection))))

## Joystick events

data JoyAxisEventData Source #

Joystick axis motion event information

Constructors

JoyAxisEventData |

Fields

- joyAxisEventWhich :: !JoystickID

  The instance id of the joystick that reported the event.

- joyAxisEventAxis :: !Word8

  The index of the axis that changed.

- joyAxisEventValue :: !Int16

  The current position of the axis, ranging between -32768 and 32767.

#### Instances

Instances details

Generic JoyAxisEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep JoyAxisEventData :: Type -> Type Source # Methods from :: JoyAxisEventData -> Rep JoyAxisEventData x Source # to :: Rep JoyAxisEventData x -> JoyAxisEventData Source #
Show JoyAxisEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> JoyAxisEventData -> ShowS Source # show :: JoyAxisEventData -> String Source # showList :: [JoyAxisEventData] -> ShowS Source #
Eq JoyAxisEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: JoyAxisEventData -> JoyAxisEventData -> Bool Source # (/=) :: JoyAxisEventData -> JoyAxisEventData -> Bool Source #
Ord JoyAxisEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: JoyAxisEventData -> JoyAxisEventData -> Ordering Source #

(<) :: JoyAxisEventData -> JoyAxisEventData -> Bool Source #

(<=) :: JoyAxisEventData -> JoyAxisEventData -> Bool Source #

(>) :: JoyAxisEventData -> JoyAxisEventData -> Bool Source #

(>=) :: JoyAxisEventData -> JoyAxisEventData -> Bool Source #

max :: JoyAxisEventData -> JoyAxisEventData -> JoyAxisEventData Source #

min :: JoyAxisEventData -> JoyAxisEventData -> JoyAxisEventData Source #

type Rep JoyAxisEventData Source # |

Instance details

Defined in SDL.Event

type Rep JoyAxisEventData = D1 ('MetaData "JoyAxisEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "JoyAxisEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "joyAxisEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoystickID) :*: (S1 ('MetaSel ('Just "joyAxisEventAxis") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word8) :*: S1 ('MetaSel ('Just "joyAxisEventValue") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int16))))

data JoyBallEventData Source #

Joystick trackball motion event information.

Constructors

JoyBallEventData |

Fields

- joyBallEventWhich :: !JoystickID

  The instance id of the joystick that reported the event.

- joyBallEventBall :: !Word8

  The index of the trackball that changed.

- joyBallEventRelMotion :: !(V2 Int16)

  The relative motion of the trackball.

#### Instances

Instances details

Generic JoyBallEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep JoyBallEventData :: Type -> Type Source # Methods from :: JoyBallEventData -> Rep JoyBallEventData x Source # to :: Rep JoyBallEventData x -> JoyBallEventData Source #
Show JoyBallEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> JoyBallEventData -> ShowS Source # show :: JoyBallEventData -> String Source # showList :: [JoyBallEventData] -> ShowS Source #
Eq JoyBallEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: JoyBallEventData -> JoyBallEventData -> Bool Source # (/=) :: JoyBallEventData -> JoyBallEventData -> Bool Source #
Ord JoyBallEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: JoyBallEventData -> JoyBallEventData -> Ordering Source #

(<) :: JoyBallEventData -> JoyBallEventData -> Bool Source #

(<=) :: JoyBallEventData -> JoyBallEventData -> Bool Source #

(>) :: JoyBallEventData -> JoyBallEventData -> Bool Source #

(>=) :: JoyBallEventData -> JoyBallEventData -> Bool Source #

max :: JoyBallEventData -> JoyBallEventData -> JoyBallEventData Source #

min :: JoyBallEventData -> JoyBallEventData -> JoyBallEventData Source #

type Rep JoyBallEventData Source # |

Instance details

Defined in SDL.Event

type Rep JoyBallEventData = D1 ('MetaData "JoyBallEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "JoyBallEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "joyBallEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoystickID) :*: (S1 ('MetaSel ('Just "joyBallEventBall") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word8) :*: S1 ('MetaSel ('Just "joyBallEventRelMotion") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (V2 Int16)))))

data JoyHatEventData Source #

Joystick hat position change event information

Constructors

JoyHatEventData |

Fields

- joyHatEventWhich :: !JoystickID

  The instance id of the joystick that reported the event.

- joyHatEventHat :: !Word8

  The index of the hat that changed.

- joyHatEventValue :: !JoyHatPosition

  The new position of the hat.

#### Instances

Instances details

Generic JoyHatEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep JoyHatEventData :: Type -> Type Source # Methods from :: JoyHatEventData -> Rep JoyHatEventData x Source # to :: Rep JoyHatEventData x -> JoyHatEventData Source #
Show JoyHatEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> JoyHatEventData -> ShowS Source # show :: JoyHatEventData -> String Source # showList :: [JoyHatEventData] -> ShowS Source #
Eq JoyHatEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: JoyHatEventData -> JoyHatEventData -> Bool Source # (/=) :: JoyHatEventData -> JoyHatEventData -> Bool Source #
Ord JoyHatEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: JoyHatEventData -> JoyHatEventData -> Ordering Source #

(<) :: JoyHatEventData -> JoyHatEventData -> Bool Source #

(<=) :: JoyHatEventData -> JoyHatEventData -> Bool Source #

(>) :: JoyHatEventData -> JoyHatEventData -> Bool Source #

(>=) :: JoyHatEventData -> JoyHatEventData -> Bool Source #

max :: JoyHatEventData -> JoyHatEventData -> JoyHatEventData Source #

min :: JoyHatEventData -> JoyHatEventData -> JoyHatEventData Source #

type Rep JoyHatEventData Source # |

Instance details

Defined in SDL.Event

type Rep JoyHatEventData = D1 ('MetaData "JoyHatEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "JoyHatEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "joyHatEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoystickID) :*: (S1 ('MetaSel ('Just "joyHatEventHat") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word8) :*: S1 ('MetaSel ('Just "joyHatEventValue") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoyHatPosition))))

data JoyButtonEventData Source #

Joystick button event information.

Constructors

JoyButtonEventData |

Fields

- joyButtonEventWhich :: !JoystickID

  The instance id of the joystick that reported the event.

- joyButtonEventButton :: !Word8

  The index of the button that changed.

- joyButtonEventState :: !JoyButtonState

  The state of the button.

#### Instances

Instances details

Generic JoyButtonEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep JoyButtonEventData :: Type -> Type Source # Methods from :: JoyButtonEventData -> Rep JoyButtonEventData x Source # to :: Rep JoyButtonEventData x -> JoyButtonEventData Source #
Show JoyButtonEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> JoyButtonEventData -> ShowS Source # show :: JoyButtonEventData -> String Source # showList :: [JoyButtonEventData] -> ShowS Source #
Eq JoyButtonEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: JoyButtonEventData -> JoyButtonEventData -> Bool Source # (/=) :: JoyButtonEventData -> JoyButtonEventData -> Bool Source #
Ord JoyButtonEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: JoyButtonEventData -> JoyButtonEventData -> Ordering Source #

(<) :: JoyButtonEventData -> JoyButtonEventData -> Bool Source #

(<=) :: JoyButtonEventData -> JoyButtonEventData -> Bool Source #

(>) :: JoyButtonEventData -> JoyButtonEventData -> Bool Source #

(>=) :: JoyButtonEventData -> JoyButtonEventData -> Bool Source #

max :: JoyButtonEventData -> JoyButtonEventData -> JoyButtonEventData Source #

min :: JoyButtonEventData -> JoyButtonEventData -> JoyButtonEventData Source #

type Rep JoyButtonEventData Source # |

Instance details

Defined in SDL.Event

type Rep JoyButtonEventData = D1 ('MetaData "JoyButtonEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "JoyButtonEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "joyButtonEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoystickID) :*: (S1 ('MetaSel ('Just "joyButtonEventButton") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word8) :*: S1 ('MetaSel ('Just "joyButtonEventState") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoyButtonState))))

data JoyDeviceEventData Source #

Joystick device event information.

Constructors

JoyDeviceEventData |

Fields

- joyDeviceEventConnection :: !JoyDeviceConnection

  Was the device added or removed?

- joyDeviceEventWhich :: !JoystickID

  The instance id of the joystick that reported the event.

#### Instances

Instances details

Generic JoyDeviceEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep JoyDeviceEventData :: Type -> Type Source # Methods from :: JoyDeviceEventData -> Rep JoyDeviceEventData x Source # to :: Rep JoyDeviceEventData x -> JoyDeviceEventData Source #
Show JoyDeviceEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> JoyDeviceEventData -> ShowS Source # show :: JoyDeviceEventData -> String Source # showList :: [JoyDeviceEventData] -> ShowS Source #
Eq JoyDeviceEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: JoyDeviceEventData -> JoyDeviceEventData -> Bool Source # (/=) :: JoyDeviceEventData -> JoyDeviceEventData -> Bool Source #
Ord JoyDeviceEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: JoyDeviceEventData -> JoyDeviceEventData -> Ordering Source #

(<) :: JoyDeviceEventData -> JoyDeviceEventData -> Bool Source #

(<=) :: JoyDeviceEventData -> JoyDeviceEventData -> Bool Source #

(>) :: JoyDeviceEventData -> JoyDeviceEventData -> Bool Source #

(>=) :: JoyDeviceEventData -> JoyDeviceEventData -> Bool Source #

max :: JoyDeviceEventData -> JoyDeviceEventData -> JoyDeviceEventData Source #

min :: JoyDeviceEventData -> JoyDeviceEventData -> JoyDeviceEventData Source #

type Rep JoyDeviceEventData Source # |

Instance details

Defined in SDL.Event

type Rep JoyDeviceEventData = D1 ('MetaData "JoyDeviceEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "JoyDeviceEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "joyDeviceEventConnection") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoyDeviceConnection) :*: S1 ('MetaSel ('Just "joyDeviceEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoystickID)))

## Controller events

data ControllerAxisEventData Source #

Game controller axis motion event information.

Constructors

ControllerAxisEventData |

Fields

- controllerAxisEventWhich :: !JoystickID

  The joystick instance ID that reported the event.

- controllerAxisEventAxis :: !ControllerAxis

  The index of the axis.

- controllerAxisEventValue :: !Int16

  The axis value ranging between -32768 and 32767.

#### Instances

Instances details

Generic ControllerAxisEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep ControllerAxisEventData :: Type -> Type Source # Methods from :: ControllerAxisEventData -> Rep ControllerAxisEventData x Source # to :: Rep ControllerAxisEventData x -> ControllerAxisEventData Source #
Show ControllerAxisEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> ControllerAxisEventData -> ShowS Source # show :: ControllerAxisEventData -> String Source # showList :: [ControllerAxisEventData] -> ShowS Source #
Eq ControllerAxisEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: ControllerAxisEventData -> ControllerAxisEventData -> Bool Source # (/=) :: ControllerAxisEventData -> ControllerAxisEventData -> Bool Source #
Ord ControllerAxisEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: ControllerAxisEventData -> ControllerAxisEventData -> Ordering Source #

(<) :: ControllerAxisEventData -> ControllerAxisEventData -> Bool Source #

(<=) :: ControllerAxisEventData -> ControllerAxisEventData -> Bool Source #

(>) :: ControllerAxisEventData -> ControllerAxisEventData -> Bool Source #

(>=) :: ControllerAxisEventData -> ControllerAxisEventData -> Bool Source #

max :: ControllerAxisEventData -> ControllerAxisEventData -> ControllerAxisEventData Source #

min :: ControllerAxisEventData -> ControllerAxisEventData -> ControllerAxisEventData Source #

type Rep ControllerAxisEventData Source # |

Instance details

Defined in SDL.Event

type Rep ControllerAxisEventData = D1 ('MetaData "ControllerAxisEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "ControllerAxisEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "controllerAxisEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoystickID) :*: (S1 ('MetaSel ('Just "controllerAxisEventAxis") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 ControllerAxis) :*: S1 ('MetaSel ('Just "controllerAxisEventValue") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int16))))

data ControllerButtonEventData Source #

Game controller button event information

Constructors

ControllerButtonEventData |

Fields

- controllerButtonEventWhich :: !JoystickID

  The joystick instance ID that reported the event.

- controllerButtonEventButton :: !ControllerButton

  The controller button.

- controllerButtonEventState :: !ControllerButtonState

  The state of the button.

#### Instances

Instances details

Generic ControllerButtonEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep ControllerButtonEventData :: Type -> Type Source # Methods from :: ControllerButtonEventData -> Rep ControllerButtonEventData x Source # to :: Rep ControllerButtonEventData x -> ControllerButtonEventData Source #
Show ControllerButtonEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> ControllerButtonEventData -> ShowS Source # show :: ControllerButtonEventData -> String Source # showList :: [ControllerButtonEventData] -> ShowS Source #
Eq ControllerButtonEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: ControllerButtonEventData -> ControllerButtonEventData -> Bool Source # (/=) :: ControllerButtonEventData -> ControllerButtonEventData -> Bool Source #
Ord ControllerButtonEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: ControllerButtonEventData -> ControllerButtonEventData -> Ordering Source #

(<) :: ControllerButtonEventData -> ControllerButtonEventData -> Bool Source #

(<=) :: ControllerButtonEventData -> ControllerButtonEventData -> Bool Source #

(>) :: ControllerButtonEventData -> ControllerButtonEventData -> Bool Source #

(>=) :: ControllerButtonEventData -> ControllerButtonEventData -> Bool Source #

max :: ControllerButtonEventData -> ControllerButtonEventData -> ControllerButtonEventData Source #

min :: ControllerButtonEventData -> ControllerButtonEventData -> ControllerButtonEventData Source #

type Rep ControllerButtonEventData Source # |

Instance details

Defined in SDL.Event

type Rep ControllerButtonEventData = D1 ('MetaData "ControllerButtonEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "ControllerButtonEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "controllerButtonEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoystickID) :*: (S1 ('MetaSel ('Just "controllerButtonEventButton") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 ControllerButton) :*: S1 ('MetaSel ('Just "controllerButtonEventState") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 ControllerButtonState))))

data ControllerDeviceEventData Source #

Controller device event information

Constructors

ControllerDeviceEventData |

Fields

- controllerDeviceEventConnection :: !ControllerDeviceConnection

  Was the device added, removed, or remapped?

- controllerDeviceEventWhich :: !JoystickID

  The joystick instance ID that reported the event.

#### Instances

Instances details

Generic ControllerDeviceEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep ControllerDeviceEventData :: Type -> Type Source # Methods from :: ControllerDeviceEventData -> Rep ControllerDeviceEventData x Source # to :: Rep ControllerDeviceEventData x -> ControllerDeviceEventData Source #
Show ControllerDeviceEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> ControllerDeviceEventData -> ShowS Source # show :: ControllerDeviceEventData -> String Source # showList :: [ControllerDeviceEventData] -> ShowS Source #
Eq ControllerDeviceEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: ControllerDeviceEventData -> ControllerDeviceEventData -> Bool Source # (/=) :: ControllerDeviceEventData -> ControllerDeviceEventData -> Bool Source #
Ord ControllerDeviceEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: ControllerDeviceEventData -> ControllerDeviceEventData -> Ordering Source #

(<) :: ControllerDeviceEventData -> ControllerDeviceEventData -> Bool Source #

(<=) :: ControllerDeviceEventData -> ControllerDeviceEventData -> Bool Source #

(>) :: ControllerDeviceEventData -> ControllerDeviceEventData -> Bool Source #

(>=) :: ControllerDeviceEventData -> ControllerDeviceEventData -> Bool Source #

max :: ControllerDeviceEventData -> ControllerDeviceEventData -> ControllerDeviceEventData Source #

min :: ControllerDeviceEventData -> ControllerDeviceEventData -> ControllerDeviceEventData Source #

type Rep ControllerDeviceEventData Source # |

Instance details

Defined in SDL.Event

type Rep ControllerDeviceEventData = D1 ('MetaData "ControllerDeviceEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "ControllerDeviceEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "controllerDeviceEventConnection") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 ControllerDeviceConnection) :*: S1 ('MetaSel ('Just "controllerDeviceEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoystickID)))

## Audio events

data AudioDeviceEventData Source #

Constructors

AudioDeviceEventData |

Fields

- audioDeviceEventIsAddition :: !Bool

  If the audio device is an addition, or a removal.

- audioDeviceEventWhich :: !Word32

  The audio device ID that reported the event.

- audioDeviceEventIsCapture :: !Bool

  If the audio device is a capture device.

#### Instances

Instances details

Generic AudioDeviceEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep AudioDeviceEventData :: Type -> Type Source # Methods from :: AudioDeviceEventData -> Rep AudioDeviceEventData x Source # to :: Rep AudioDeviceEventData x -> AudioDeviceEventData Source #
Show AudioDeviceEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> AudioDeviceEventData -> ShowS Source # show :: AudioDeviceEventData -> String Source # showList :: [AudioDeviceEventData] -> ShowS Source #
Eq AudioDeviceEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: AudioDeviceEventData -> AudioDeviceEventData -> Bool Source # (/=) :: AudioDeviceEventData -> AudioDeviceEventData -> Bool Source #
Ord AudioDeviceEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: AudioDeviceEventData -> AudioDeviceEventData -> Ordering Source #

(<) :: AudioDeviceEventData -> AudioDeviceEventData -> Bool Source #

(<=) :: AudioDeviceEventData -> AudioDeviceEventData -> Bool Source #

(>) :: AudioDeviceEventData -> AudioDeviceEventData -> Bool Source #

(>=) :: AudioDeviceEventData -> AudioDeviceEventData -> Bool Source #

max :: AudioDeviceEventData -> AudioDeviceEventData -> AudioDeviceEventData Source #

min :: AudioDeviceEventData -> AudioDeviceEventData -> AudioDeviceEventData Source #

type Rep AudioDeviceEventData Source # |

Instance details

Defined in SDL.Event

type Rep AudioDeviceEventData = D1 ('MetaData "AudioDeviceEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "AudioDeviceEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "audioDeviceEventIsAddition") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Bool) :*: (S1 ('MetaSel ('Just "audioDeviceEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word32) :*: S1 ('MetaSel ('Just "audioDeviceEventIsCapture") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Bool))))

## User events

data UserEventData Source #

Event data for application-defined events.

Constructors

UserEventData |

Fields

- userEventType :: !Word32

  User defined event type.

- userEventWindow :: !(Maybe Window)

  The associated `Window`.

- userEventCode :: !Int32

  User defined event code.

- userEventData1 :: !(Ptr ())

  User defined data pointer.

- userEventData2 :: !(Ptr ())

  User defined data pointer.

#### Instances

Instances details

Generic UserEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep UserEventData :: Type -> Type Source # Methods from :: UserEventData -> Rep UserEventData x Source # to :: Rep UserEventData x -> UserEventData Source #
Show UserEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> UserEventData -> ShowS Source # show :: UserEventData -> String Source # showList :: [UserEventData] -> ShowS Source #
Eq UserEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: UserEventData -> UserEventData -> Bool Source # (/=) :: UserEventData -> UserEventData -> Bool Source #
Ord UserEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: UserEventData -> UserEventData -> Ordering Source #

(<) :: UserEventData -> UserEventData -> Bool Source #

(<=) :: UserEventData -> UserEventData -> Bool Source #

(>) :: UserEventData -> UserEventData -> Bool Source #

(>=) :: UserEventData -> UserEventData -> Bool Source #

max :: UserEventData -> UserEventData -> UserEventData Source #

min :: UserEventData -> UserEventData -> UserEventData Source #

type Rep UserEventData Source # |

Instance details

Defined in SDL.Event

type Rep UserEventData = D1 ('MetaData "UserEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "UserEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "userEventType") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word32) :*: S1 ('MetaSel ('Just "userEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Maybe Window))) :*: (S1 ('MetaSel ('Just "userEventCode") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int32) :*: (S1 ('MetaSel ('Just "userEventData1") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Ptr ())) :*: S1 ('MetaSel ('Just "userEventData2") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Ptr ()))))))

## Touch events

data TouchFingerEventData Source #

Finger touch event information.

Constructors

TouchFingerEventData |

Fields

- touchFingerEventTouchID :: !TouchID

  The touch device index.

- touchFingerEventFingerID :: !FingerID

  The finger index.

- touchFingerEventMotion :: !InputMotion

  Whether the finger was pressed or released.

- touchFingerEventPos :: !(Point V2 CFloat)

  The location of the touch event, normalized between 0 and 1.

- touchFingerEventPressure :: !CFloat

  The quantity of the pressure applied, normalized between 0 and 1.

#### Instances

Instances details

Generic TouchFingerEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep TouchFingerEventData :: Type -> Type Source # Methods from :: TouchFingerEventData -> Rep TouchFingerEventData x Source # to :: Rep TouchFingerEventData x -> TouchFingerEventData Source #
Show TouchFingerEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> TouchFingerEventData -> ShowS Source # show :: TouchFingerEventData -> String Source # showList :: [TouchFingerEventData] -> ShowS Source #
Eq TouchFingerEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: TouchFingerEventData -> TouchFingerEventData -> Bool Source # (/=) :: TouchFingerEventData -> TouchFingerEventData -> Bool Source #
Ord TouchFingerEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: TouchFingerEventData -> TouchFingerEventData -> Ordering Source #

(<) :: TouchFingerEventData -> TouchFingerEventData -> Bool Source #

(<=) :: TouchFingerEventData -> TouchFingerEventData -> Bool Source #

(>) :: TouchFingerEventData -> TouchFingerEventData -> Bool Source #

(>=) :: TouchFingerEventData -> TouchFingerEventData -> Bool Source #

max :: TouchFingerEventData -> TouchFingerEventData -> TouchFingerEventData Source #

min :: TouchFingerEventData -> TouchFingerEventData -> TouchFingerEventData Source #

type Rep TouchFingerEventData Source # |

Instance details

Defined in SDL.Event

type Rep TouchFingerEventData = D1 ('MetaData "TouchFingerEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "TouchFingerEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "touchFingerEventTouchID") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 TouchID) :*: S1 ('MetaSel ('Just "touchFingerEventFingerID") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 FingerID)) :*: (S1 ('MetaSel ('Just "touchFingerEventMotion") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 InputMotion) :*: (S1 ('MetaSel ('Just "touchFingerEventPos") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Point V2 CFloat)) :*: S1 ('MetaSel ('Just "touchFingerEventPressure") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 CFloat)))))

data TouchFingerMotionEventData Source #

Finger motion event information.

Constructors

TouchFingerMotionEventData |

Fields

- touchFingerMotionEventTouchID :: !TouchID

  The touch device index.

- touchFingerMotionEventFingerID :: !FingerID

  The finger index.

- touchFingerMotionEventPos :: !(Point V2 CFloat)

  The location of the touch event, normalized between 0 and 1.

- touchFingerMotionEventRelMotion :: !(V2 CFloat)

  The distance moved, normalized between -1 and 1.

- touchFingerMotionEventPressure :: !CFloat

  The quantity of the pressure applied, normalized between 0 and 1.

#### Instances

Instances details

Generic TouchFingerMotionEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep TouchFingerMotionEventData :: Type -> Type Source # Methods from :: TouchFingerMotionEventData -> Rep TouchFingerMotionEventData x Source # to :: Rep TouchFingerMotionEventData x -> TouchFingerMotionEventData Source #
Show TouchFingerMotionEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> TouchFingerMotionEventData -> ShowS Source # show :: TouchFingerMotionEventData -> String Source # showList :: [TouchFingerMotionEventData] -> ShowS Source #
Eq TouchFingerMotionEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> Bool Source # (/=) :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> Bool Source #
Ord TouchFingerMotionEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> Ordering Source #

(<) :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> Bool Source #

(<=) :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> Bool Source #

(>) :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> Bool Source #

(>=) :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> Bool Source #

max :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> TouchFingerMotionEventData Source #

min :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> TouchFingerMotionEventData Source #

type Rep TouchFingerMotionEventData Source # |

Instance details

Defined in SDL.Event

type Rep TouchFingerMotionEventData = D1 ('MetaData "TouchFingerMotionEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "TouchFingerMotionEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "touchFingerMotionEventTouchID") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 TouchID) :*: S1 ('MetaSel ('Just "touchFingerMotionEventFingerID") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 FingerID)) :*: (S1 ('MetaSel ('Just "touchFingerMotionEventPos") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Point V2 CFloat)) :*: (S1 ('MetaSel ('Just "touchFingerMotionEventRelMotion") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (V2 CFloat)) :*: S1 ('MetaSel ('Just "touchFingerMotionEventPressure") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 CFloat)))))

## Gesture events

data MultiGestureEventData Source #

Multiple finger gesture event information

Constructors

MultiGestureEventData |

Fields

- multiGestureEventTouchID :: !TouchID

  The touch device index.

- multiGestureEventDTheta :: !CFloat

  The amount that the fingers rotated during this motion.

- multiGestureEventDDist :: !CFloat

  The amount that the fingers pinched during this motion.

- multiGestureEventPos :: !(Point V2 CFloat)

  The normalized center of the gesture.

- multiGestureEventNumFingers :: !Word16

  The number of fingers used in this gesture.

#### Instances

Instances details

Generic MultiGestureEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep MultiGestureEventData :: Type -> Type Source # Methods from :: MultiGestureEventData -> Rep MultiGestureEventData x Source # to :: Rep MultiGestureEventData x -> MultiGestureEventData Source #
Show MultiGestureEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> MultiGestureEventData -> ShowS Source # show :: MultiGestureEventData -> String Source # showList :: [MultiGestureEventData] -> ShowS Source #
Eq MultiGestureEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: MultiGestureEventData -> MultiGestureEventData -> Bool Source # (/=) :: MultiGestureEventData -> MultiGestureEventData -> Bool Source #
Ord MultiGestureEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: MultiGestureEventData -> MultiGestureEventData -> Ordering Source #

(<) :: MultiGestureEventData -> MultiGestureEventData -> Bool Source #

(<=) :: MultiGestureEventData -> MultiGestureEventData -> Bool Source #

(>) :: MultiGestureEventData -> MultiGestureEventData -> Bool Source #

(>=) :: MultiGestureEventData -> MultiGestureEventData -> Bool Source #

max :: MultiGestureEventData -> MultiGestureEventData -> MultiGestureEventData Source #

min :: MultiGestureEventData -> MultiGestureEventData -> MultiGestureEventData Source #

type Rep MultiGestureEventData Source # |

Instance details

Defined in SDL.Event

type Rep MultiGestureEventData = D1 ('MetaData "MultiGestureEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "MultiGestureEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "multiGestureEventTouchID") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 TouchID) :*: S1 ('MetaSel ('Just "multiGestureEventDTheta") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 CFloat)) :*: (S1 ('MetaSel ('Just "multiGestureEventDDist") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 CFloat) :*: (S1 ('MetaSel ('Just "multiGestureEventPos") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Point V2 CFloat)) :*: S1 ('MetaSel ('Just "multiGestureEventNumFingers") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word16)))))

data DollarGestureEventData Source #

Complex gesture event information.

Constructors

DollarGestureEventData |

Fields

- dollarGestureEventTouchID :: !TouchID

  The touch device index.

- dollarGestureEventGestureID :: !GestureID

  The unique id of the closest gesture to the performed stroke.

- dollarGestureEventNumFingers :: !Word32

  The number of fingers used to draw the stroke.

- dollarGestureEventError :: !CFloat

  The difference between the gesture template and the actual performed gesture (lower errors correspond to closer matches).

- dollarGestureEventPos :: !(Point V2 CFloat)

  The normalized center of the gesture.

#### Instances

Instances details

Generic DollarGestureEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep DollarGestureEventData :: Type -> Type Source # Methods from :: DollarGestureEventData -> Rep DollarGestureEventData x Source # to :: Rep DollarGestureEventData x -> DollarGestureEventData Source #
Show DollarGestureEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> DollarGestureEventData -> ShowS Source # show :: DollarGestureEventData -> String Source # showList :: [DollarGestureEventData] -> ShowS Source #
Eq DollarGestureEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: DollarGestureEventData -> DollarGestureEventData -> Bool Source # (/=) :: DollarGestureEventData -> DollarGestureEventData -> Bool Source #
Ord DollarGestureEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: DollarGestureEventData -> DollarGestureEventData -> Ordering Source #

(<) :: DollarGestureEventData -> DollarGestureEventData -> Bool Source #

(<=) :: DollarGestureEventData -> DollarGestureEventData -> Bool Source #

(>) :: DollarGestureEventData -> DollarGestureEventData -> Bool Source #

(>=) :: DollarGestureEventData -> DollarGestureEventData -> Bool Source #

max :: DollarGestureEventData -> DollarGestureEventData -> DollarGestureEventData Source #

min :: DollarGestureEventData -> DollarGestureEventData -> DollarGestureEventData Source #

type Rep DollarGestureEventData Source # |

Instance details

Defined in SDL.Event

type Rep DollarGestureEventData = D1 ('MetaData "DollarGestureEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "DollarGestureEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "dollarGestureEventTouchID") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 TouchID) :*: S1 ('MetaSel ('Just "dollarGestureEventGestureID") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 GestureID)) :*: (S1 ('MetaSel ('Just "dollarGestureEventNumFingers") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word32) :*: (S1 ('MetaSel ('Just "dollarGestureEventError") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 CFloat) :*: S1 ('MetaSel ('Just "dollarGestureEventPos") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Point V2 CFloat))))))

## Drag and drop events

newtype DropEventData Source #

An event used to request a file open by the system

Constructors

DropEventData |

Fields

- dropEventFile :: CString

  The file name.

#### Instances

Instances details

Generic DropEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep DropEventData :: Type -> Type Source # Methods from :: DropEventData -> Rep DropEventData x Source # to :: Rep DropEventData x -> DropEventData Source #
Show DropEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> DropEventData -> ShowS Source # show :: DropEventData -> String Source # showList :: [DropEventData] -> ShowS Source #
Eq DropEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: DropEventData -> DropEventData -> Bool Source # (/=) :: DropEventData -> DropEventData -> Bool Source #
Ord DropEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: DropEventData -> DropEventData -> Ordering Source #

(<) :: DropEventData -> DropEventData -> Bool Source #

(<=) :: DropEventData -> DropEventData -> Bool Source #

(>) :: DropEventData -> DropEventData -> Bool Source #

(>=) :: DropEventData -> DropEventData -> Bool Source #

max :: DropEventData -> DropEventData -> DropEventData Source #

min :: DropEventData -> DropEventData -> DropEventData Source #

type Rep DropEventData Source # |
Instance details Defined in SDL.Event type Rep DropEventData = D1 ('MetaData "DropEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'True) (C1 ('MetaCons "DropEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "dropEventFile") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 CString)))

## Unknown events

newtype UnknownEventData Source #

SDL reported an unknown event type.

Constructors

UnknownEventData |

Fields

- unknownEventType :: Word32

  The unknown event code.

#### Instances

Instances details

Generic UnknownEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep UnknownEventData :: Type -> Type Source # Methods from :: UnknownEventData -> Rep UnknownEventData x Source # to :: Rep UnknownEventData x -> UnknownEventData Source #
Show UnknownEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> UnknownEventData -> ShowS Source # show :: UnknownEventData -> String Source # showList :: [UnknownEventData] -> ShowS Source #
Eq UnknownEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: UnknownEventData -> UnknownEventData -> Bool Source # (/=) :: UnknownEventData -> UnknownEventData -> Bool Source #
Ord UnknownEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: UnknownEventData -> UnknownEventData -> Ordering Source #

(<) :: UnknownEventData -> UnknownEventData -> Bool Source #

(<=) :: UnknownEventData -> UnknownEventData -> Bool Source #

(>) :: UnknownEventData -> UnknownEventData -> Bool Source #

(>=) :: UnknownEventData -> UnknownEventData -> Bool Source #

max :: UnknownEventData -> UnknownEventData -> UnknownEventData Source #

min :: UnknownEventData -> UnknownEventData -> UnknownEventData Source #

type Rep UnknownEventData Source # |
Instance details Defined in SDL.Event type Rep UnknownEventData = D1 ('MetaData "UnknownEventData" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'True) (C1 ('MetaCons "UnknownEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "unknownEventType") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Word32)))

# Auxiliary event data

data InputMotion Source #

Constructors

Released |
Pressed |

#### Instances

Instances details

Data InputMotion Source # |

Instance details

Defined in SDL.Event

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> InputMotion -> c InputMotion Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c InputMotion Source #

toConstr :: InputMotion -> Constr Source #

dataTypeOf :: InputMotion -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c InputMotion) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c InputMotion) Source #

gmapT :: (forall b. Data b => b -> b) -> InputMotion -> InputMotion Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> InputMotion -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> InputMotion -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> InputMotion -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> InputMotion -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> InputMotion -> m InputMotion Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> InputMotion -> m InputMotion Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> InputMotion -> m InputMotion Source #

Bounded InputMotion Source # |
Instance details Defined in SDL.Event Methods minBound :: InputMotion Source # maxBound :: InputMotion Source #
Enum InputMotion Source # |

Instance details

Defined in SDL.Event

Methods

succ :: InputMotion -> InputMotion Source #

pred :: InputMotion -> InputMotion Source #

toEnum :: Int -> InputMotion Source #

fromEnum :: InputMotion -> Int Source #

enumFrom :: InputMotion -> [InputMotion] Source #

enumFromThen :: InputMotion -> InputMotion -> [InputMotion] Source #

enumFromTo :: InputMotion -> InputMotion -> [InputMotion] Source #

enumFromThenTo :: InputMotion -> InputMotion -> InputMotion -> [InputMotion] Source #

Generic InputMotion Source # |
Instance details Defined in SDL.Event Associated Types type Rep InputMotion :: Type -> Type Source # Methods from :: InputMotion -> Rep InputMotion x Source # to :: Rep InputMotion x -> InputMotion Source #
Read InputMotion Source # |
Instance details Defined in SDL.Event Methods readsPrec :: Int -> ReadS InputMotion Source # readList :: ReadS [InputMotion] Source # readPrec :: ReadPrec InputMotion Source # readListPrec :: ReadPrec [InputMotion] Source #
Show InputMotion Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> InputMotion -> ShowS Source # show :: InputMotion -> String Source # showList :: [InputMotion] -> ShowS Source #
Eq InputMotion Source # |
Instance details Defined in SDL.Event Methods (==) :: InputMotion -> InputMotion -> Bool Source # (/=) :: InputMotion -> InputMotion -> Bool Source #
Ord InputMotion Source # |

Instance details

Defined in SDL.Event

Methods

compare :: InputMotion -> InputMotion -> Ordering Source #

(<) :: InputMotion -> InputMotion -> Bool Source #

(<=) :: InputMotion -> InputMotion -> Bool Source #

(>) :: InputMotion -> InputMotion -> Bool Source #

(>=) :: InputMotion -> InputMotion -> Bool Source #

max :: InputMotion -> InputMotion -> InputMotion Source #

min :: InputMotion -> InputMotion -> InputMotion Source #

type Rep InputMotion Source # |
Instance details Defined in SDL.Event type Rep InputMotion = D1 ('MetaData "InputMotion" "SDL.Event" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) (C1 ('MetaCons "Released" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "Pressed" 'PrefixI 'False) (U1 :: Type -> Type))

data MouseButton Source #

Constructors

ButtonLeft |
ButtonMiddle |
ButtonRight |
ButtonX1 |
ButtonX2 |
ButtonExtra !Int | An unknown mouse button.

#### Instances

Instances details

Data MouseButton Source # |

Instance details

Defined in SDL.Input.Mouse

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> MouseButton -> c MouseButton Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c MouseButton Source #

toConstr :: MouseButton -> Constr Source #

dataTypeOf :: MouseButton -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c MouseButton) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c MouseButton) Source #

gmapT :: (forall b. Data b => b -> b) -> MouseButton -> MouseButton Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> MouseButton -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> MouseButton -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> MouseButton -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> MouseButton -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> MouseButton -> m MouseButton Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> MouseButton -> m MouseButton Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> MouseButton -> m MouseButton Source #

Generic MouseButton Source # |
Instance details Defined in SDL.Input.Mouse Associated Types type Rep MouseButton :: Type -> Type Source # Methods from :: MouseButton -> Rep MouseButton x Source # to :: Rep MouseButton x -> MouseButton Source #
Read MouseButton Source # |
Instance details Defined in SDL.Input.Mouse Methods readsPrec :: Int -> ReadS MouseButton Source # readList :: ReadS [MouseButton] Source # readPrec :: ReadPrec MouseButton Source # readListPrec :: ReadPrec [MouseButton] Source #
Show MouseButton Source # |
Instance details Defined in SDL.Input.Mouse Methods showsPrec :: Int -> MouseButton -> ShowS Source # show :: MouseButton -> String Source # showList :: [MouseButton] -> ShowS Source #
Eq MouseButton Source # |
Instance details Defined in SDL.Input.Mouse Methods (==) :: MouseButton -> MouseButton -> Bool Source # (/=) :: MouseButton -> MouseButton -> Bool Source #
Ord MouseButton Source # |

Instance details

Defined in SDL.Input.Mouse

Methods

compare :: MouseButton -> MouseButton -> Ordering Source #

(<) :: MouseButton -> MouseButton -> Bool Source #

(<=) :: MouseButton -> MouseButton -> Bool Source #

(>) :: MouseButton -> MouseButton -> Bool Source #

(>=) :: MouseButton -> MouseButton -> Bool Source #

max :: MouseButton -> MouseButton -> MouseButton Source #

min :: MouseButton -> MouseButton -> MouseButton Source #

FromNumber MouseButton Word8 Source # |
Instance details Defined in SDL.Input.Mouse Methods fromNumber :: Word8 -> MouseButton Source #
ToNumber MouseButton Word8 Source # |
Instance details Defined in SDL.Input.Mouse Methods toNumber :: MouseButton -> Word8 Source #
type Rep MouseButton Source # |

Instance details

Defined in SDL.Input.Mouse

type Rep MouseButton = D1 ('MetaData "MouseButton" "SDL.Input.Mouse" "sdl2-2.5.5.0-1rHVQtCfQoNJ4T4oR9opIh" 'False) ((C1 ('MetaCons "ButtonLeft" 'PrefixI 'False) (U1 :: Type -> Type) :+: (C1 ('MetaCons "ButtonMiddle" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "ButtonRight" 'PrefixI 'False) (U1 :: Type -> Type))) :+: (C1 ('MetaCons "ButtonX1" 'PrefixI 'False) (U1 :: Type -> Type) :+: (C1 ('MetaCons "ButtonX2" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "ButtonExtra" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int)))))